/*
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>
//#include <star_pci_bridge.h>

#if 0
#define DEBUG
#endif

#if (CONFIG_COMMANDS & CFG_CMD_NET) && defined(CONFIG_NET_MULTI) \
	&& defined(CONFIG_RT2880_ETH)

#include <malloc.h>
#include <net.h>
#include <asm/addrspace.h>

#ifndef CFG_BOARD_WRGN16
#include "rtl8366s/rtl8366s_types.h"
#endif

/*  Phy Vender ID list */
#define EV_MARVELL_PHY_ID0 0x0141
#define EV_MARVELL_PHY_ID1 0x0CC2

extern ulong rt2880_uboot_code_start_addr;
extern ulong	*rt2880_top_dram_addr;

#define RT2880_BIT(x)              ((1 << x))

/* ====================================== */
#define RT2880_GDM1_DISPAD       RT2880_BIT(18)
#define RT2880_GDM1_DISCRC       RT2880_BIT(17)
#define RT2880_GDM1_STRPCRC      RT2880_BIT(16)
//GDMA1 uni-cast frames destination port
#define RT2880_GDM1_UFRC_P_CPU     ((u32)(~(0x7 << 12)))
#define RT2880_GDM1_UFRC_P_GDMA1   (1 << 12)
#define RT2880_GDM1_UFRC_P_ppe     (6 << 12)
#define RT2880_GDM1_UFRC_P_DROP    (7 << 12)
//GDMA1 broad-cast MAC address frames
#define RT2880_GDM1_BFRC_P_CPU      ((u32)(~(0x7 << 8)))
#define RT2880_GDM1_BFRC_P_GDMA1   (1 << 8)
#define RT2880_GDM1_BFRC_P_PPE     (6 << 8)
#define RT2880_GDM1_BFRC_P_DROP    (7 << 8)
//GDMA1 multi-cast MAC address frames
#define RT2880_GDM1_MFRC_P_CPU      ((u32)(~(0x7 << 4)))
#define RT2880_GDM1_MFRC_P_GDMA1    (1 << 4)
#define RT2880_GDM1_MFRC_P_PPE      (6 << 4)
#define RT2880_GDM1_MFRC_P_DROP      (7 << 4)
//GDMA1 other MAC address frames destination port
#define RT2880_GDM1_OFRC_P_CPU     ((u32)(~(0x7)))
#define RT2880_GDM1_OFRC_P_GDMA1   1
#define RT2880_GDM1_OFRC_P_PPE     6
#define RT2880_GDM1_OFRC_P_DROP    7
/* ====================================== */
/* ====================================== */
#define RT2880_GP1_LNK_DWN     RT2880_BIT(9)
#define RT2880_GP1_AN_FAIL     RT2880_BIT(8)
/* ====================================== */
/* ====================================== */
#define RT2880_PSE_RESET       RT2880_BIT(0)
/* ====================================== */
#define RT2880_PST_DRX_IDX0       RT2880_BIT(16)
#define RT2880_PST_DTX_IDX1       RT2880_BIT(1)
#define RT2880_PST_DTX_IDX0       RT2880_BIT(0)

#define RT2880_TX_WB_DDONE       RT2880_BIT(6)
#define RT2880_RX_DMA_BUSY       RT2880_BIT(3)
#define RT2880_TX_DMA_BUSY       RT2880_BIT(1)
#define RT2880_RX_DMA_EN         RT2880_BIT(2)
#define RT2880_TX_DMA_EN         RT2880_BIT(0)

#define RT2880_GP1_FRC_EN         RT2880_BIT(15)

#define RT2880_GP1_FC_TX        RT2880_BIT(11)
#define RT2880_GP1_FC_RX        RT2880_BIT(10)
#define RT2880_GP1_LINK_DWN     RT2880_BIT(9)
/*
     FE_INT_STATUS
*/
#define RT2880_CNT_PPE_AF       RT2880_BIT(31)
#define RT2880_CNT_GDM1_AF      RT2880_BIT(29)
#define RT2880_PSE_P1_FC        RT2880_BIT(22)
#define RT2880_PSE_P0_FC        RT2880_BIT(21)
#define RT2880_PSE_FQ_EMPTY     RT2880_BIT(20)
#define RT2880_GE1_STA_CHG      RT2880_BIT(18)
#define RT2880_TX_COHERENT      RT2880_BIT(17)
#define RT2880_RX_COHERENT      RT2880_BIT(16)

#define RT2880_TX_DONE_INT1     RT2880_BIT(9)
#define RT2880_TX_DONE_INT0     RT2880_BIT(8)
#define RT2880_RX_DONE_INT0     RT2880_BIT(2)
#define RT2880_TX_DLY_INT       RT2880_BIT(1)
#define RT2880_RX_DLY_INT       RT2880_BIT(0)

/* Ethernet chip registers.RT2880
 */
#ifdef RT2880_FPGA_B_VER_BOARD
#define RT2880_ETH_BASE  0xA0400000
#else
#define RT2880_ETH_BASE    0xA0310000
#endif

#define RT2880_FRAME_ENGINE_GLOBAL 0x0000
#define RT2880_MDIO_ACCESS         0x00
#define RT2880_MDIO_CFG            0x04
#define RT2880_FE_DMA_GLO_CFG      0x08
#define RT2880_FE_RST_GLO          0x0C
#define RT2880_FE_INT_STATUS       0x10
#define RT2880_FE_INT_ENABLE       0x14
#define RT2880_FC_DROP_STA         0x18
#define RT2880_FOE_TS_T            0x1C
#define RT2880_GDMA_RELATED        0x0020
#define RT2880_GDMA1_FWD_CFG       (RT2880_GDMA_RELATED + 0x00)

#define RT2880_GDMA1_SCH_CFG       (RT2880_GDMA_RELATED + 0x04)
#define RT2880_GDMA1_SHRP_CFG      (RT2880_GDMA_RELATED + 0x08)
#define RT2880_GDMA1_MAC_ADRL      (RT2880_GDMA_RELATED + 0x0C)
#define RT2880_GDMA1_MAC_ADRH      (RT2880_GDMA_RELATED + 0x10)

#define RT2880_PSE_RELATED         0x0040
#define RT2880_PSE_FQFC_CFG        (RT2880_PSE_RELATED + 0x00)
#define RT2880_GDMA1_FC_CFG        (RT2880_PSE_RELATED + 0x04)
#define RT2880_CDMA_FC_CFG         (RT2880_PSE_RELATED + 0x0C)
#define RT2880_CDMA_OQ_STA         (RT2880_PSE_RELATED + 0x10)
#define RT2880_GDMA1_OQ_STA        (RT2880_PSE_RELATED + 0x14)
#define RT2880_PPE_OQ_STA          (RT2880_PSE_RELATED + 0x18)
#define RT2880_PSE_IQ_STA          (RT2880_PSE_RELATED + 0x1C)
#define RT2880_FQ_STA              (RT2880_PSE_RELATED + 0x20)

#define RT2880_CDMA_RELATED        0x0080
#define RT2880_CDMA_CSG_CFG        (RT2880_CDMA_RELATED + 0x00)
#define RT2880_CDMA_SCH_CFG        (RT2880_CDMA_RELATED + 0x04)

#define RT2880_PDMA_RELATED        0x0100
#define RT2880_PDMA_GLO_CFG        (RT2880_PDMA_RELATED + 0x00)
#define RT2880_PDMA_RST_IDX        (RT2880_PDMA_RELATED + 0x04)
#define RT2880_PDMA_SCH_CFG        (RT2880_PDMA_RELATED + 0x08)
#define RT2880_DELAY_INT_CFG       (RT2880_PDMA_RELATED + 0x0C)
#define RT2880_TX_BASE_PTR0        (RT2880_PDMA_RELATED + 0x10)
#define RT2880_TX_MAX_CNT0         (RT2880_PDMA_RELATED + 0x14)
#define RT2880_TX_CTX_IDX0         (RT2880_PDMA_RELATED + 0x18)
#define RT2880_TX_DTX_IDX0         (RT2880_PDMA_RELATED + 0x1C)
#define RT2880_TX_BASE_PTR1        (RT2880_PDMA_RELATED + 0x20)
#define RT2880_TX_MAX_CNT1         (RT2880_PDMA_RELATED + 0x24)
#define RT2880_TX_CTX_IDX1         (RT2880_PDMA_RELATED + 0x28)
#define RT2880_TX_DTX_IDX1         (RT2880_PDMA_RELATED + 0x2C)
#define RT2880_RX_BASE_PTR0        (RT2880_PDMA_RELATED + 0x30)
#define RT2880_RX_MAX_CNT0         (RT2880_PDMA_RELATED + 0x34)
#define RT2880_RX_CALC_IDX0        (RT2880_PDMA_RELATED + 0x38)
#define RT2880_RX_DRX_IDX0         (RT2880_PDMA_RELATED + 0x3C)

#define RT2880_PPE_RELATED         0x0200

#define RT2880_INTERNAL_LOOPBACK_ENABLE 1

#define RT2880_INTERNAL_LOOPBACK_DISABLE 0

#define RT2880_ESRAM_ON  1

#define RT2880_ESRAM_OFF 0

/*****************************************/
//PCI define

//RTL8139.h..................................................

#define DelayCount                              0X8000
#define RTL8139_DEVICE_VENDOR_ID	0x813910EC
#define PCI_BRIDGE_DEVICE_VENDOR_ID 0x0000eeee
#define RTL8139_VENDOR_ID                       0x10EC
#define RTL8139_DEVICE_ID                       0x8139
#define RTL8139_RX_BUFFER_LENGTH        		(32 * 1024)
#define RX_MAX_PACKET_LENGTH					1518
#define RX_MIN_PACKET_LENGTH			 		60
#define PACKET_CRC_LENGTH						4
#define RTL8139_TX_BUF_NUM						0x100
#define PACKET_HDR_LENGTH						14

//#define PCI_BRIDGE_DMA_SIZE                         0x0       //power of 2 =>16(MB)
//*** PCI Bridge Definition Configuration Space & Value
#define PCI_BRIDGE_CONFIGURATION_SPACE_CONTROL      0x4C
#define PCI_BRIDGE_CONFIGURATION_INTABCD_STATUS     0x4F
#define PCI_BRIDGE_CONFIGURATION_INTMASK            0x4E
#define PCI_BRIDGE_CONFIGURATION_SPACE_MEM1_BA      0x80000050
#define PCI_BRIDGE_CONFIGURATION_SPACE_MEM2_BA      0x80000054
#define PCI_BRIDGE_CONFIGURATION_SPACE_MEM3_BA      0x80000058
#define PCI_ENABLE_INTA_INTB_INTC_INTD              0x03C00000
#define PCI_BRIDGE_MAX_INT_NUMBER                   0x04
#define PCI_DMA_MEM_REQUEST_FAIL                    0xFFFFFFFF
#define PCI_DMA_DEFAULT_SIZE                        0x00
#define PCI_MAX_SLOT_NUM                            0x04
#define PCI_BRIDGE_MAX_INT_NUMBER                   0x04
// PCI dev ID define
#define PCI_BRIDGE_ID                 0x4321159B
#define PCI_RTL8139_ID                0x813910EC
/*3.PCI configuration register */
#define PCI_CSH_VENDOR_ID_REG					    0x00
#define PCI_CSH_DEVICE_ID_REG					    0x02
#define PCI_CSH_COMMAND_REG					        0x04
#define PCI_CSH_STATUS_REG					        0x06
#define PCI_CSH_REVISION_CLASS_REG				    0x08
#define PCI_CSH_CACHE_LINE_SIZE_REG				    0x0C
#define PCI_CSH_LATENCY_TIMER_REG				    0x0D
#define PCI_CSH_HEADER_TYPE_REG					    0x0E
#define PCI_CSH_BIST_REG					        0x0F
#define	PCI_CSH_BASE_ADDR_REG					    0x10

/*7.Alignment Constants */
#define PCI_MEM_SPACE_ALIGNMENT				        0x10
#define PCI_IO_SPACE_ALIGNMENT				        0x4

#define SYS_DDR_SDRAM_BASE_ADDR                0x00000000

#define PCI_ALLOCATE_SPACE 0x20000000

/*5.PCI command status register bit mapping */
#define PCI_CMD_IO_ENABLE					        0x00000001
#define PCI_CMD_MEM_ENABLE					        0x00000002
#define PCI_CMD_BUS_MASTER_ENABLE   		                0x00000004
#define PCI_CMD_MEM_WRITE_INVALIDATE                      0X00000010
#define PCI_CMD_PARITY_ERR						0x00000040
#define PCI_CMD_STEPPING_CONTROL				0x00000080
#define PCI_CMD_SERR_ENABLE   		                	0x00000100
#define PCI_CMD_FBB_ENABLE						0x00000200

typedef struct
{
 u32	RegNum:8;
 u32	FunNum:3;
 u32	DevNum:5;
 u32	BusNum:8;
 u32	Always0:7;
 u32	Enable:1;
}PCIDeviceIDStruct;

struct _PCI_DEV
{
	u32       dev_ven;
	PCIDeviceIDStruct  PCIDeviceID;
};

//kaiker
#define RALINK_PCI_BAR0SETUP_ADDR *(volatile u32 *)(0xA0301010)
#define RALINK_PCI_BAR1SETUP_ADDR *(volatile u32 *)(0xA0301014)
#define RALINK_PCI_IMBASEBAR0_ADDR *(volatile u32 *)(0xA0301018)
#define RALINK_PCI_IMBASEBAR1_ADDR *(volatile u32 *)(0xA030101C)

struct _PCI_DEV Finded_PCIDeviceID[PCI_MAX_SLOT_NUM];
/*****************************************/

#ifdef EV_BOARD
static void rt2880_mdio_set(u32 addr,u32 bit_offset,u32 value );
#endif

static inline void mips_cache_set(u32 v);

static int INL(struct eth_device* dev, u_long addr);
static void OUTL(struct eth_device* dev, int command, u_long addr);

#ifndef BOB_USE
u32 Gsw_Read_PHY(u32 phy_register, u32 *read_data);
u32 Gsw_Write_PHY(u32 phy_register, u32 write_data);
#endif

void RESET_RT2880_ETH(dev) {
	u_long value;
	#if 0
	u32 i;
    i=INL(dev, RT2880_FE_RST_GLO);
	//puts("\n RESET_RT2880_ETH is called 1 !!\n");
    udelay(100);
    OUTL(dev, i | RT2880_PSE_RESET ,RT2880_FE_RST_GLO);
	//puts("\n RESET_RT2880_ETH is called 2 !!\n");
    udelay(100);

    i=INL(dev, RT2880_PDMA_RST_IDX);
	//puts("\n RESET_RT2880_ETH is called 3 !!\n");
    udelay(100);
    OUTL(dev, i | RT2880_PST_DRX_IDX0 | RT2880_PST_DTX_IDX1 |  RT2880_PST_DTX_IDX0  ,RT2880_PDMA_RST_IDX);

	//puts("\n RESET_RT2880_ETH is called 4 !!\n");
    udelay(100);
	#endif

	value = le32_to_cpu(*(volatile u_long *)(0xa0300034));
//	printf("%x -> (%x)\n", addr+dev->iobase, value);

	//printf("\n 1.addr[0xa0300034]=%08X !!\n",value);
    udelay(100);

    value |= (1 << 18);

	*(volatile u_long *)(0xa0300034) = cpu_to_le32(value);


    udelay(200);
	value = le32_to_cpu(*(volatile u_long *)(0xa0300034));
//
	//printf("\n 2.addr[0xa0300034]=%08X !!\n",value);
}

void START_RT2880_ETH(struct eth_device *dev ) {
    s32 omr;
    omr=INL(dev, RT2880_PDMA_GLO_CFG);
    udelay(100);
	omr |= RT2880_TX_WB_DDONE | RT2880_RX_DMA_EN | RT2880_TX_DMA_EN ;
    OUTL(dev, omr, RT2880_PDMA_GLO_CFG);
	udelay(500);
}

void STOP_RT2880_ETH(struct eth_device *dev) {
    s32 omr;
    omr=INL(dev, RT2880_PDMA_GLO_CFG);
    udelay(100);
	omr &= ~(RT2880_TX_WB_DDONE | RT2880_RX_DMA_EN | RT2880_TX_DMA_EN) ;
    OUTL(dev, omr, RT2880_PDMA_GLO_CFG);
	udelay(500);
}

#define RX_BUFF_SZ  PKTSIZE_ALIGN

#define TOUT_LOOP   1000

#define ENABLE 1
#define DISABLE 0

/*=======================================*/
VALID_BUFFER_STRUCT  rt2880_free_buf_list;
VALID_BUFFER_STRUCT  rt2880_busing_buf_list;
static BUFFER_ELEM   rt2880_free_buf[PKTBUFSRX];
/*=======================================*/
struct palmeth_desc {
volatile s32 status;
u32 des1;
u32 buf;
u32 next;
};

#if 1
/*=========================================
      PDMA RX Descriptor Format define
=========================================*/
//-------------------------------------------------
typedef struct _PDMA_RXD_INFO1_  PDMA_RXD_INFO1_T;

struct _PDMA_RXD_INFO1_
{
    unsigned int    PDP0;
};
//-------------------------------------------------
typedef struct _PDMA_RXD_INFO2_    PDMA_RXD_INFO2_T;

struct _PDMA_RXD_INFO2_
{
    unsigned int    PLEN1                  : 14;
    unsigned int    LS1                   : 1;
    unsigned int    UN_USED               : 1;
    unsigned int    PLEN0                  : 14;
    unsigned int    LS0                   : 1;
    unsigned int    DDONE_bit             : 1;
};
//-------------------------------------------------
typedef struct _PDMA_RXD_INFO3_  PDMA_RXD_INFO3_T;

struct _PDMA_RXD_INFO3_
{
    unsigned int    PDP1;
};
//-------------------------------------------------
typedef struct _PDMA_RXD_INFO4_    PDMA_RXD_INFO4_T;

struct _PDMA_RXD_INFO4_
{

    unsigned int    FOE_Entry           : 14;
    unsigned int    FVLD                : 1;
    unsigned int    UN_USE1             : 1;
	unsigned int    AI                  : 8;
    unsigned int    SP                  : 3;
    unsigned int    AIS                 : 1;
    unsigned int    L4F                 : 1;
    unsigned int    IPF                  : 1;
    unsigned int    L4FVLD_bit           : 1;
    unsigned int    IPFVLD_bit           : 1;
};

struct PDMA_rxdesc {
	PDMA_RXD_INFO1_T rxd_info1;
	PDMA_RXD_INFO2_T rxd_info2;
	PDMA_RXD_INFO3_T rxd_info3;
	PDMA_RXD_INFO4_T rxd_info4;
};
#endif

/*=========================================
      PDMA TX Descriptor Format define
=========================================*/
//-------------------------------------------------
typedef struct _PDMA_TXD_INFO1_  PDMA_TXD_INFO1_T;

struct _PDMA_TXD_INFO1_
{
    unsigned int    SDP0;
};
//-------------------------------------------------
typedef struct _PDMA_TXD_INFO2_    PDMA_TXD_INFO2_T;

struct _PDMA_TXD_INFO2_
{
    unsigned int    SDL1                  : 14;
    unsigned int    LS1_bit               : 1;
    unsigned int    BURST_bit             : 1;
    unsigned int    SDL0                  : 14;
    unsigned int    LS0_bit               : 1;
    unsigned int    DDONE_bit             : 1;
};
//-------------------------------------------------
typedef struct _PDMA_TXD_INFO3_  PDMA_TXD_INFO3_T;

struct _PDMA_TXD_INFO3_
{
    unsigned int    SDP1;
};
//-------------------------------------------------
typedef struct _PDMA_TXD_INFO4_    PDMA_TXD_INFO4_T;

struct _PDMA_TXD_INFO4_
{

    unsigned int    VIDX                : 4;
    unsigned int    VPRI                : 3;
    unsigned int    INSV                : 1;
    unsigned int    SIDX                : 4;
    unsigned int    INSP                : 1;
    unsigned int    UN_USE3             : 3;
	unsigned int    QN                  : 3;
    unsigned int    UN_USE2             : 5;
    unsigned int    PN                  : 3;
    unsigned int    UN_USE1             : 2;
    unsigned int    TC0                 : 1;
    unsigned int    UC0_bit             : 1;
    unsigned int    IC0_bit             : 1;
};

struct PDMA_txdesc {
	PDMA_TXD_INFO1_T txd_info1;
	PDMA_TXD_INFO2_T txd_info2;
	PDMA_TXD_INFO3_T txd_info3;
	PDMA_TXD_INFO4_T txd_info4;
};



static  struct PDMA_txdesc tx_ring0_cache[NUM_TX_DESC] __attribute__ ((aligned(32))); /* TX descriptor ring         */
static  struct PDMA_rxdesc rx_ring_cache[NUM_RX_DESC] __attribute__ ((aligned(32))); /* RX descriptor ring         */

static int rx_dma_owner_idx0;                             /* Point to the next RXD DMA wants to use in RXD Ring#0.  */
static int rx_wants_alloc_idx0;                             /* Point to the next RXD CPU wants to allocate to RXD Ring #0. */
static int tx_cpu_owner_idx0;                             /* Point to the next TXD in TXD_Ring0 CPU wants to use */
static int tx_cpu_owner_idx1;
static volatile struct PDMA_rxdesc *rx_ring;
static volatile struct PDMA_txdesc *tx_ring0;
#ifdef RT2880_DUPLICATE_TX_RING
static volatile struct PDMA_txdesc *tx_ring1;
static  struct PDMA_txdesc tx_ring1_cache[NUM_TX_DESC] __attribute__ ((aligned(32))); /* TX descriptor ring         */
#endif

static char rxRingSize;
static char txRingSize;

//static void  send_setup_frame(struct eth_device* dev, bd_t * bis);

static int   rt2880_eth_init(struct eth_device* dev, bd_t* bis);
static int   rt2880_eth_send(struct eth_device* dev, volatile void *packet, int length);
static int   rt2880_eth_recv(struct eth_device* dev);
void  rt2880_eth_halt(struct eth_device* dev);

static int   rt2880_eth_setup(struct eth_device* dev);
static int rt2880_eth_initd;
static ulong Tt_start;

static int eth_loopback_mode,loopback_protect;

static int force_queue_n;

static int sdp0_alig_16n_x;
static int sdp1_alig_16n_x;
static int internal_loopback_test;
static int rt2880_esram_gear;
static int rt2880_size_of_mem;

static int header_payload_scatter_en;
static u32 rt2880_hdrlen;
static int rt2880_buf_in_esram_en;
static int rt2880_desc_in_esram;
static int rt2880_sdp0_buf_in_esram_en;
static int rt2880_debug_en;

extern char	console_buffer[CFG_CBSIZE];		/* console I/O buffer	*/

#define phys_to_bus(a) (a & 0x1FFFFFFF)

#define PCI_WAIT_INPUT_CHAR(ch) while((ch = getc())== 0)

struct eth_device* 	rt2880_pdev;
volatile uchar	*PKT_HEADER_Buf;// = (uchar *)CFG_EMBEDED_SRAM_SDP0_BUF_START;
static volatile uchar	PKT_HEADER_Buf_Pool[(PKTBUFSRX * PKTSIZE_ALIGN) + PKTALIGN];
static volatile uchar	*pkthdrbuf[PKTBUFSRX];
extern volatile uchar *NetTxPacket;	/* THE transmit packet			*/
extern volatile uchar	*PktBuf;
extern volatile uchar	Pkt_Buf_Pool[];

#define RT2880_MDIO_ACCESS_R  le32_to_cpu(*(volatile u_long *)(RT2880_ETH_BASE+RT2880_MDIO_ACCESS))
#define RT2880_MDIO_CFG_R  le32_to_cpu(*(volatile u_long *)(RT2880_ETH_BASE+RT2880_MDIO_CFG))

#ifdef RT2880_PCI_0310
#define PCI_BRIDGE_CONFIG_ADDR le32_to_cpu(*(volatile u_long *)(0xA0301020))
#define PCI_BRIDGE_CONFIG_DATA le32_to_cpu(*(volatile u_long *)(0xA0301024))
#define PCI_BRIDGE_CLOCK le32_to_cpu(*(volatile u_long *)(0xA0300030))
#define PCI_MEMBASE le32_to_cpu(*(volatile u_long *)(0xA0301028))
#define PCI_IOBASE le32_to_cpu(*(volatile u_long *)(0xA030102C))
#define PCI_MEMWIN(offset) le32_to_cpu(*(volatile u_long *)(0xA0301040 + offset))
#define PCI_IOWIN(offset) le32_to_cpu(*(volatile u_long *)(0xA0301060 + offset))
#else /* !RT2880_PCI_0310 */
#ifdef RT2880_FPGA_B_VER_BOARD
#define PCI_BRIDGE_CONFIG_ADDR *(volatile u_long *)(0xA0440020)
#define PCI_BRIDGE_CONFIG_DATA *(volatile u_long *)(0xA0440024)
#define PCI_BRIDGE_CLOCK *(volatile u_long *)(0xA0300030)
#define PCI_MEMBASE *(volatile u_long *)(0xA0440028)
#define PCI_IOBASE *(volatile u_long *)(0xA044002C)
#define PCI_MEMWIN(offset) *(volatile u_long *)(0xA0510000 + offset)
#define PCI_IOWIN(offset) *(volatile u_long *)(0xA0520000 + offset)
#define PCI_PCICFG_REG le32_to_cpu(*(volatile u_long *)(0xA0440000))
#define PCI_ARBCTL_REG le32_to_cpu(*(volatile u_long *)(0xA0440080))
#else /* !RT2880_FPGA_B_VER_BOARD */
#define PCI_BRIDGE_CONFIG_ADDR le32_to_cpu(*(volatile u_long *)(0xA0500020))
#define PCI_BRIDGE_CONFIG_DATA le32_to_cpu(*(volatile u_long *)(0xA0500024))
#define PCI_BRIDGE_CLOCK le32_to_cpu(*(volatile u_long *)(0xA0300030))
#define PCI_MEMBASE le32_to_cpu(*(volatile u_long *)(0xA0500028))
#define PCI_IOBASE le32_to_cpu(*(volatile u_long *)(0xA050002C))
#define PCI_MEMWIN(offset) le32_to_cpu(*(volatile u_long *)(0xA0510000 + offset))
#define PCI_IOWIN(offset) le32_to_cpu(*(volatile u_long *)(0xA0520000 + offset))
#define PCI_PCICFG_REG le32_to_cpu(*(volatile u_long *)(0xA0500000))
#define PCI_ARBCTL_REG le32_to_cpu(*(volatile u_long *)(0xA0500080))
#endif /* end of RT2880_FPGA_B_VER_BOARD */
#endif /* end of RT2880_PCI_0310 */

#define RT2880_FREEBUF_OFFSET(CURR)  ((int)(((0x0FFFFFFF & (u32)CURR) - (u32) (0x0FFFFFFF & (u32) rt2880_free_buf[0].pbuf)) / 1536))

static int INL(struct eth_device* dev, u_long addr)
{
	u_long value;
	value = le32_to_cpu(*(volatile u_long *)(addr + dev->iobase));
//	printf("%x -> (%x)\n", addr+dev->iobase, value);
	return (value);
//	return le32_to_cpu(*(volatile u_long *)(addr + dev->iobase));
}

static void OUTL(struct eth_device* dev, int command, u_long addr)
{
	*(volatile u_long *)(addr + dev->iobase) = cpu_to_le32(command);
//	printf("@ %x-- (%x)   ", addr, command);
//	INL(dev, addr);
}

static void gmac_phy_switch_gear(int i)
{
	u32 regValue;

	return;

	if(i == ENABLE)
	{
		Gsw_Read_PHY(0,&regValue);

		regValue &= ~(1<<11);

		Gsw_Write_PHY(0,regValue);

		printf("\n GMAC Phy Power Up \n");
	}
	else
	{
		Gsw_Read_PHY(0,&regValue);

		regValue |= (1<<11);

		Gsw_Write_PHY(0,regValue);

		printf("\n GMAC Phy Power Down \n");
	}

}

BUFFER_ELEM *rt2880_free_buf_entry_dequeue(VALID_BUFFER_STRUCT *hdr)
{
    int     zero = 0;           /* causes most compilers to place this */
                                    /* value in a register only once */
    BUFFER_ELEM  *node;

    /* Make sure we were not passed a null pointer. */
    if (!hdr)
    {
        return (NULL);
    }

    /* If there is a node in the list we want to remove it. */
    if (hdr->head)
    {
        /* Get the node to be removed */
        node = hdr->head;

        /* Make the hdr point the second node in the list */
        hdr->head = node->next;

        /* If this is the last node the headers tail pointer needs to be nulled
           We do not need to clear the node's next since it is already null */
        if (!(hdr->head))
        {
            hdr->tail = (BUFFER_ELEM *)zero;
        }
            node->next = (BUFFER_ELEM *)zero;
	}
    else
    {
        node = NULL;
		return (node);
    }

    /*  Restore the previous interrupt lockout level.  */
    /* Return a pointer to the removed node */
	//shnat_validation_flow_table_entry[node->index].state = SHNAT_FLOW_TABLE_NODE_USED;
    return (node);
}

static BUFFER_ELEM *rt2880_free_buf_entry_enqueue(VALID_BUFFER_STRUCT *hdr, BUFFER_ELEM *item)
{
	int zero =0;

    if (!hdr)
    {
        return (NULL);
    }

    if (item != NULL)
    {
        /* Temporarily lockout interrupts to protect global buffer variables. */
       // Sys_Interrupt_Disable_Save_Flags(&cpsr_flags);

        /* Set node's next to point at NULL */
        item->next = (BUFFER_ELEM *)zero;

        /*  If there is currently a node in the linked list, we want to add the
            new node to the end. */
        if (hdr->head)
        {
            /* Make the last node's next point to the new node. */
            hdr->tail->next = item;

            /* Make the roots tail point to the new node */
            hdr->tail = item;
        }
        else
        {
            /* If the linked list was empty, we want both the root's head and
               tial to point to the new node. */
            hdr->head = item;
            hdr->tail = item;
        }
        /*  Restore the previous interrupt lockout level.  */
    }
	else
	{
		printf("\n shnat_flow_table_free_entry_enqueue is called,item== NULL \n");
	}

    return(item);

} /* MEM_Buffer_Enqueue */


int rt2880_eth_initialize(bd_t *bis)
{
	struct eth_device* 	dev;

	int	i;
	u32	regValue;

#if 0
   {
      /* switch PHY software reset */
      u32 *read_data, reg= 0;

      Gsw_Read_PHY(reg, read_data);
      udelay(100);
      *read_data |= (1 << 15 );
      Gsw_Write_PHY(reg, *read_data);
      udelay(100);
      Gsw_Read_PHY(reg, read_data);
      udelay(100);
      while( *read_data & (1 << 15) ) {
         printf("Giga PHY software reset\n");
         Gsw_Read_PHY(reg, read_data);
         udelay(100);
      }
   }
#endif

	if (!(dev = (struct eth_device *) malloc (sizeof *dev))) {
		printf("Failed to allocate memory\n");
		return 0;
	}

	memset(dev, 0, sizeof(*dev));

	sprintf(dev->name, "Eth0 (10/100-M)");

	dev->iobase = RT2880_ETH_BASE;
	dev->init   = rt2880_eth_init;
	dev->halt   = rt2880_eth_halt;
	dev->send   = rt2880_eth_send;
	dev->recv   = rt2880_eth_recv;

	eth_register(dev);
#if 0
	Gsw_Read_PHY(0,&regValue);

	regValue |= (1<<11);

	Gsw_Write_PHY(0,regValue);
#endif
	eth_loopback_mode = 0;
	rt2880_pdev = dev;
	loopback_protect = 0;

	force_queue_n = 3;
	sdp0_alig_16n_x = 0;
	sdp1_alig_16n_x = 0;
	rt2880_eth_initd =0;
	rt2880_size_of_mem = 0;
	rt2880_esram_gear = RT2880_ESRAM_OFF;
	internal_loopback_test = RT2880_INTERNAL_LOOPBACK_DISABLE;
	header_payload_scatter_en = DISABLE;
	rt2880_buf_in_esram_en = DISABLE;
	rt2880_desc_in_esram = DISABLE;
	rt2880_sdp0_buf_in_esram_en = DISABLE;
	PktBuf = Pkt_Buf_Pool;
	PKT_HEADER_Buf = PKT_HEADER_Buf_Pool;
	rt2880_hdrlen = 20;
	NetTxPacket = NULL;
	rt2880_debug_en = DISABLE;
	rx_ring = KSEG1ADDR((ulong)&rx_ring_cache[0]);
	tx_ring0 = KSEG1ADDR((ulong)&tx_ring0_cache[0]);



	rt2880_free_buf_list.head = NULL;
	rt2880_free_buf_list.tail = NULL;

	rt2880_busing_buf_list.head = NULL;
	rt2880_busing_buf_list.tail = NULL;

	//2880_free_buf



		/*
		 *	Setup packet buffers, aligned correctly.
		 */
		rt2880_free_buf[0].pbuf = &PktBuf[0] + (PKTALIGN - 1);
		rt2880_free_buf[0].pbuf -= (ulong)rt2880_free_buf[0].pbuf % PKTALIGN;
		rt2880_free_buf[0].next = NULL;

		rt2880_free_buf_entry_enqueue(&rt2880_free_buf_list,&rt2880_free_buf[0]);

   #ifdef DEBUG
		printf("\n rt2880_free_buf[0].pbuf = 0x%08X \n",rt2880_free_buf[0].pbuf);
	#endif
		for (i = 1; i < PKTBUFSRX; i++) {
			rt2880_free_buf[i].pbuf = rt2880_free_buf[0].pbuf + (i)*PKTSIZE_ALIGN;
			rt2880_free_buf[i].next = NULL;
		#ifdef DEBUG
			printf("\n rt2880_free_buf[%d].pbuf = 0x%08X\n",i,rt2880_free_buf[i].pbuf);
      #endif
			rt2880_free_buf_entry_enqueue(&rt2880_free_buf_list,&rt2880_free_buf[i]);
		}

		for (i = 0; i < PKTBUFSRX; i++)
		{
			rt2880_free_buf[i].tx_idx = NUM_TX_DESC;
		#ifdef DEBUG
			printf("\n rt2880_free_buf[%d] = 0x%08X,rt2880_free_buf[%d].next=0x%08X \n",i,&rt2880_free_buf[i],i,rt2880_free_buf[i].next);
		#endif
		}
	{
	//set clock resolution
	unsigned long my_tmp;
	my_tmp = *(unsigned long *)(0xa0310008);
	*(unsigned long *)(0xa0310008) = my_tmp | 0x0000ff00;
	}
	return 1;
}


#if (CONFIG_COMMANDS & CFG_CMD_MII)


#endif	/* CONFIG_COMMANDS & CFG_CMD_MII */

static int rt2880_eth_init(struct eth_device* dev, bd_t* bis)
{

	ulong t_start;
	u32 regValue;

//	regValue = INL(dev, RT2880_GDMA1_FWD_CFG);
//	printf("\n RT2880_GDMA1_FWD_CFG = %08X \n",regValue);

	//if(rt2880_eth_initd == 0)
	//{
	   rt2880_eth_setup(dev);
	    Tt_start = get_timer(0);
	//}

#if 0
    while(1)
    {
	 	if (!(INL(dev, RT2880_MDIO_CFG) & (RT2880_GP1_LNK_DWN)))
		{
	    	printf(" GMAC1 link up !!.\n");
			udelay(500);
	    	break;
	   	}
    }

    while(1)
    {

	    if (!(INL(dev, RT2880_MDIO_CFG) & (RT2880_GP1_AN_FAIL)))
		{
		    printf("Auto-negotiation Finish !!.\n");
			udelay(500);
		    break;
		}
    }

		START_RT2880_ETH(dev);

    	printf("\n START_RT2880_ETH \n");
#endif

	rt2880_eth_initd = 1;

	return (1);
}


static int rt2880_eth_setup(struct eth_device* dev)
{

	int	i,count;
	u32	regValue,kk,phy_id0,phy_id1;
	u16 wTmp;
	ulong t_start,t_start1;
    uchar *temp;
    	unsigned long my_tmp;

#if 0
   *(volatile u_long *)(0x00 + 0xA0300700) = (1<<8)|(1<<0);
   *(volatile u_long *)(0x20 + 0xA0300700) = (1<<8)|(1<<0);
   udelay(500);
#endif

	printf("\n Waitting  RT2880_RX_DMA_BUSY status Start.\n");

	while(1)
	{
		kk = INL(dev, RT2880_PDMA_GLO_CFG);
		if((kk & RT2880_RX_DMA_BUSY))
		{
			continue;
		}
		if((kk & RT2880_TX_DMA_BUSY))
		{
			printf("  RT2880_TX_DMA_BUSY !!! ");
			continue;
		}
		break;
	}

 	//puts(" RESET_RT2880_ETH is called !!\n");
  	////RESET_RT2880_ETH(dev); /* removed on 6/01/2006.ralink.yj */

#ifdef EV_BOARD
// Use for EV board
	regValue = RT2880_MDIO_CFG_R;
	//PHY address
	regValue &= ~(0x1F << 24);
	regValue |= (0x1F << 24);
	RT2880_MDIO_CFG_R = regValue;

	if(Gsw_Read_PHY(2,&phy_id0))
	{

	}
	else
	{
		printf(" Read PhyID 0 is Fail!!\n");
		phy_id0 =0;

	}

	if(Gsw_Read_PHY(3,&phy_id1))
	{

	}
	else
	{
		printf(" Read PhyID 1 is Fail!!\n");
		phy_id1 = 0;
	}

	if((phy_id0 == EV_MARVELL_PHY_ID0) && (phy_id1 == EV_MARVELL_PHY_ID1))
	{

		printf(" MARVELL phy\n");

		rt2880_mdio_set(20,7,1);


		rt2880_mdio_set(0,15,1);

		my_tmp = *(unsigned long *)(0xa0310008);
		*(unsigned long *)(0xa0310008) = my_tmp | 0x0000ff00;

		puts(" Phy Reset !!\n");
	}
	else
	{
		//OUTL(dev, cpu_to_le32((u32)(((INL(dev, RT2880_MDIO_CFG)&0x00ff0000))|0x1001BC01)),RT2880_MDIO_CFG);

#ifndef MAC_TO_MAC_MODE
		OUTL(dev, cpu_to_le32((u32)(0x1001BC01)), RT2880_MDIO_CFG);
#else
		regValue = RT2880_MDIO_CFG_R;
#ifdef DEBUG
		printf(" Other phy,The default =0x%08X\n",regValue);
#endif
		regValue = regValue & 0xFFFF01FF;

		regValue |= (0xD << 12) | (0xD << 8);

		OUTL(dev, cpu_to_le32(regValue), RT2880_MDIO_CFG);

		regValue = RT2880_MDIO_CFG_R;
#ifdef DEBUG
		printf(" Other phy,The set value =0x%08X\n",regValue);
#endif

#endif //MAC_TO_MAC_MODE

	//Leo
#ifndef CFG_BOARD_WRGN16
		{
			printf(" RTL8366SR init... \n");
			uint32 phyData;
			uint32 i;

			smi_reset(0, 0);

			for (i=0; i < 1000; i++)
				udelay(1000);

		    if (rtl8366s_initChip() == FAILED)
		        printf("Phy init failed!!\n");
		    else
		        printf(" Phy init success!!\n");

			//rtl8366s_setCPUPort(5, TRUE, FALSE);
		    rtl8366s_getAsicPHYRegs(1,0,2,&phyData);
#ifdef DEBUG
		    printf("PHY_ID1:%x\n", phyData);
#endif
		    rtl8366s_getAsicPHYRegs(1,0,3,&phyData);
#ifdef DEBUG
		    printf("PHY_ID2:%x\n", phyData);
#endif
		}
#endif
	}
#endif /* EV_BOARD */

  	printf(" Enable GMAC Phy(0x%08X) !!\n", regValue);

  	gmac_phy_switch_gear(ENABLE);

     t_start = get_timer(0);
	 t_start1 = t_start;

	printf(" Waitting  to GMAC1 link up  Start!!\n");

#ifndef MAC_TO_MAC_MODE

    while(1)
    {
        //if(internal_loopback_test == RT2880_INTERNAL_LOOPBACK_ENABLE)
       // {
		//	break;
        //}

	 	if (!(INL(dev, RT2880_MDIO_CFG) & (RT2880_GP1_LNK_DWN)))
		{
	    	printf(" GMAC1 link up !!.\n");
			udelay(500);
	    	break;
	   	}

		if(get_timer(t_start)>= (2 * CFG_HZ))
		{
			 t_start = get_timer(0);
			 printf(" Waitting..Current status is Link Down !!\n");

		}
		#if 0
		if(get_timer(t_start1)>= (20 * CFG_HZ))
		{
			 puts(" Break waitting !!\n");
			 break;
		}
		#endif
    }
   #ifndef RT2880_FPGA_B_VER_BOARD
    t_start = get_timer(0);
	t_start1 = t_start;

	printf(" Waitting  to Auto-negotiation Finish Start \n");

    while(1)
    {
    	 if(internal_loopback_test == RT2880_INTERNAL_LOOPBACK_ENABLE)
		break;

	    if (!(INL(dev, RT2880_MDIO_CFG) & (RT2880_GP1_AN_FAIL)))
		{
		    printf(" Auto-negotiation Finish !!.\n");
			udelay(500);
		    break;
		}
		if(get_timer(t_start)>= (2 * CFG_HZ))
		{
			 t_start = get_timer(0);
			 printf(" Waitting..Current status is Auto-negotiation  !!\n");

		}
		#if 0
		if(get_timer(t_start1)>= (10 * CFG_HZ))
		{
			 puts(" Break waitting !!\n");
			 break;
		}
		#endif
    }
#endif
#if 0
	regValue = RT2880_MDIO_CFG_R;
	regValue= regValue & (~(RT2880_BIT(16)));
	RT2880_MDIO_CFG_R = regValue;
#endif

#endif

	/* Set MAC address.
	 */
	wTmp = (u16)dev->enetaddr[0];
	regValue = (wTmp << 8) | dev->enetaddr[1];
   // printf("\n dev->iobase=%08X,RT2880_GDMA1_MAC_ADRH=%08X \nMAC_ADRH = %08X",dev->iobase,RT2880_GDMA1_MAC_ADRH,regValue);
	OUTL(dev, regValue, RT2880_GDMA1_MAC_ADRH);

	wTmp = (u16)dev->enetaddr[2];
	regValue = (wTmp << 8) | dev->enetaddr[3];
	regValue = regValue << 16;
	wTmp = (u16)dev->enetaddr[4];
	regValue |= (wTmp<<8) | dev->enetaddr[5];
  //   printf("\n dev->iobase=%08X,RT2880_GDMA1_MAC_ADRL=%08X \n MAC_ADRL = %08X",dev->iobase,RT2880_GDMA1_MAC_ADRL,regValue);
	OUTL(dev, regValue, RT2880_GDMA1_MAC_ADRL);
	//printf("\n rt2880_eth_init,set MAC reg to [%02X:%02X:%02X:%02X:%02X:%02X]\n",
	//	dev->enetaddr[0],dev->enetaddr[1],dev->enetaddr[2],
	//	dev->enetaddr[3],dev->enetaddr[4],dev->enetaddr[5]);



    regValue = INL(dev, RT2880_GDMA1_FWD_CFG);

	//printf("\n old,RT2880_GDMA1_FWD_CFG = %08X \n",regValue);

    //Uni-cast frames forward to CPU
	regValue = regValue & RT2880_GDM1_UFRC_P_CPU;
	//Broad-cast MAC address frames forward to CPU
	regValue = regValue & RT2880_GDM1_BFRC_P_CPU;
	//Multi-cast MAC address frames forward to CPU
	regValue = regValue & RT2880_GDM1_MFRC_P_CPU;
    //Other MAC address frames forward to CPU
    regValue = regValue & RT2880_GDM1_OFRC_P_CPU;

	OUTL(dev, cpu_to_le32((u32) regValue), RT2880_GDMA1_FWD_CFG);
	udelay(500);
	regValue = INL(dev, RT2880_GDMA1_FWD_CFG);

	//printf("\n new,RT2880_GDMA1_FWD_CFG = %08X \n",regValue);



	regValue = 0x80504000;

	OUTL(dev, cpu_to_le32((u32) regValue), RT2880_PSE_FQFC_CFG);





	#ifdef RT2880_DUPLICATE_TX_RING
	tx_ring1 = KSEG1ADDR((ulong)&tx_ring1_cache[0]);
	#endif


	if(header_payload_scatter_en == ENABLE)
	{
	    temp = &PKT_HEADER_Buf[0] + (PKTALIGN - 1);
		temp -= (ulong)temp % PKTALIGN;

		for (i = 0; i < PKTBUFSRX; i++) {
			pkthdrbuf[i] = temp + (i*PKTSIZE_ALIGN) + sdp0_alig_16n_x;

			kk = (u32)pkthdrbuf[i];
#ifdef DEBUG
			printf(" pkthdrbuf[%d]=0x%08X,16N alignment= %d \n",i,kk, (kk % FLANK_TEST_SPX_ALIGNMENT));
#endif
		}
	}
#ifdef DEBUG
 	printf(" rx_ring = %08X, tx_ring0 = %08X\n",rx_ring,tx_ring0);
#endif
	for (i = 0; i < NUM_RX_DESC; i++) {

		temp = memset(&rx_ring[i],0,16);

	    rx_ring[i].rxd_info2.DDONE_bit = 0;


		if(header_payload_scatter_en == ENABLE)
		{
			NetRxPackets[i]+= sdp1_alig_16n_x;
			rx_ring[i].rxd_info1.PDP0 = cpu_to_le32(phys_to_bus((u32) pkthdrbuf[i]));
			rx_ring[i].rxd_info3.PDP1 = cpu_to_le32(phys_to_bus((u32) (NetRxPackets[i])));
			rx_ring[i].rxd_info2.LS0= 0;
			rx_ring[i].rxd_info2.LS1= 1;
#ifdef DEBUG
			printf(" rx_ring[%d].rxd_info3.PDP1 = 0x%08X",i,rx_ring[i].rxd_info3.PDP1);
#endif
		}
		else
		{
			rx_ring[i].rxd_info2.LS0= 1;
			rx_ring[i].rxd_info1.PDP0 = cpu_to_le32(phys_to_bus((u32) NetRxPackets[i]));
		}


	}

	for (i=0; i < NUM_TX_DESC; i++) {

		temp = memset(&tx_ring0[i],0,16);
		#ifdef RT2880_MUTI_TX_DESCRIPTOR
		//tx_ring0[i].txd_info2.LS1_bit = 1;
		#else
		tx_ring0[i].txd_info2.LS0_bit = 1;
		#endif
		tx_ring0[i].txd_info2.DDONE_bit = 1;
		/*
		 PN:
			0:CPU
			1:GE
			6:PPE
			7:Discard
		*/
		if(internal_loopback_test == RT2880_INTERNAL_LOOPBACK_ENABLE)
		{
			tx_ring0[i].txd_info4.PN = 0;
			printf(" Ring0,Set TX DMA loop back to CPU !! \n");
		}
		else
		tx_ring0[i].txd_info4.PN = 1;


		tx_ring0[i].txd_info4.QN = 0;



	}
	#ifdef RT2880_DUPLICATE_TX_RING

	for (i=0; i < NUM_TX_DESC; i++) {

		temp = memset(&tx_ring1[i],0,16);
		#ifdef RT2880_MUTI_TX_DESCRIPTOR
		//tx_ring1[i].txd_info2.LS1_bit = 1;
		#else
		tx_ring1[i].txd_info2.LS0_bit = 1;
		#endif
		tx_ring1[i].txd_info2.DDONE_bit = 1;
		/*
		 PN:
			0:CPU
			1:GE
			6:PPE
			7:Discard
		*/
		if(internal_loopback_test == RT2880_INTERNAL_LOOPBACK_ENABLE)
		{
			tx_ring1[i].txd_info4.PN = 0;
			printf(" Ring1,Set TX DMA loop back to CPU ! \n");
		}
		else
		tx_ring1[i].txd_info4.PN = 1;

		tx_ring1[i].txd_info4.QN = 0;



	}

	#endif

	rxRingSize = NUM_RX_DESC;
	txRingSize = NUM_TX_DESC;

	rx_dma_owner_idx0 = 0;
	rx_wants_alloc_idx0 = (NUM_RX_DESC - 1);
	tx_cpu_owner_idx0 = 0;
	tx_cpu_owner_idx1 = 0;

    regValue=INL(rt2880_pdev, RT2880_PDMA_GLO_CFG);
    udelay(100);

	if(header_payload_scatter_en == ENABLE)
	{

		regValue &= 0x000000FF;
		regValue |= (rt2880_hdrlen << 8);
    	OUTL(dev, regValue, RT2880_PDMA_GLO_CFG);
		udelay(500);
		regValue=INL(dev, RT2880_PDMA_GLO_CFG);
		printf(" Default of Header Length = 20 \n");
	}
	else
	{

		regValue &= 0x000000FF;

    	OUTL(rt2880_pdev, regValue, RT2880_PDMA_GLO_CFG);
		udelay(500);
		regValue=INL(rt2880_pdev, RT2880_PDMA_GLO_CFG);
	    printf(" Header Payload scatter function is Disable !! \n");
	}
#ifdef DEBUG
	printf(" RT2880_PDMA_GLO_CFG=%04X \n",regValue);
#endif


	#ifdef RT2880_DUPLICATE_TX_RING
	OUTL(dev, phys_to_bus((u32) &tx_ring1[0]), RT2880_TX_BASE_PTR1);
	OUTL(dev, cpu_to_le32((u32) NUM_TX_DESC), RT2880_TX_MAX_CNT1);
	OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx1), RT2880_TX_CTX_IDX1);
	#endif

	/* Tell the adapter where the TX/RX rings are located. */
	OUTL(dev, phys_to_bus((u32) &rx_ring[0]), RT2880_RX_BASE_PTR0);

	//printf("\n rx_ring=%08X ,RT2880_RX_BASE_PTR0 = %08X \n",&rx_ring[0],INL(dev,RT2880_RX_BASE_PTR0));
	OUTL(dev, phys_to_bus((u32) &tx_ring0[0]), RT2880_TX_BASE_PTR0);

	//printf("\n tx_ring0=%08X, RT2880_TX_BASE_PTR0 = %08X \n",&tx_ring0[0],INL(dev,RT2880_TX_BASE_PTR0));

	OUTL(dev, cpu_to_le32((u32) NUM_RX_DESC), RT2880_RX_MAX_CNT0);
    OUTL(dev, cpu_to_le32((u32) NUM_TX_DESC), RT2880_TX_MAX_CNT0);
	OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx0), RT2880_TX_CTX_IDX0);
    OUTL(dev, cpu_to_le32((u32) (NUM_RX_DESC - 1)), RT2880_RX_CALC_IDX0);
    //OUTL(dev, cpu_to_le32((u32) 0), RT2880_RX_DRX_IDX0);
#ifdef DEBUG
    printf(" ************************************************* \n");
	printf(" RT2880_RX_CALC_IDX0=%d \n", INL(dev,RT2880_RX_CALC_IDX0));
    printf(" RT2880_RX_DRX_IDX0 = %d \n",INL(dev,RT2880_RX_DRX_IDX0));
	printf(" ************************************************* \n");
#endif
    udelay(500);

	START_RT2880_ETH(dev);

	return 1;
}




static int rt2880_eth_send(struct eth_device* dev, volatile void *packet, int length)
{
	int		status = -1;
	int		i;
	volatile s32 *ps;
	int		retry_count = 0,bk_len = 0,temp;
	u8     *sdp1_seg_p;
	u32 *txd_info;
	static int tingx_is_free = 0;



Retry:
	if (retry_count > 10) {
		return (status);
	}

	if (length <= 0) {
		printf("%s: bad packet size: %d\n", dev->name, length);
		return (status);
	}
	#ifdef RT2880_DUPLICATE_TX_RING

	#ifdef RT2880_MUTI_TX_DESCRIPTOR
	for(i = 0; (tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 0 && tx_ring0[tx_cpu_owner_idx0 +1 ].txd_info2.DDONE_bit == 0) || (tx_ring1[tx_cpu_owner_idx1].txd_info2.DDONE_bit == 0 && tx_ring1[tx_cpu_owner_idx1 + 1].txd_info2.DDONE_bit == 0); i++)

	#else //Non RT2880_MUTI_TX_DESCRIPTOR
	for(i = 0; tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 0 || tx_ring1[tx_cpu_owner_idx1].txd_info2.DDONE_bit == 0; i++)
	#endif //RT2880_MUTI_TX_DESCRIPTOR
	#else  //Non RT2880_DUPLICATE_TX_RING
	#ifdef RT2880_MUTI_TX_DESCRIPTOR

	for(i = 0; tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 0 && tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.DDONE_bit == 0; i++)
	#else //Non RT2880_MUTI_TX_DESCRIPTOR

	for(i = 0; tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 0 ; i++)

	#endif	//RT2880_MUTI_TX_DESCRIPTOR
	#endif //RT2880_DUPLICATE_TX_RING
	{
		if (i >= TOUT_LOOP) {
			//printf("%s: TX DMA is Busy !! TX desc is Empty!\n", dev->name);
			goto Done;
		}
	}

	//dump_reg();


	temp = INL(dev,RT2880_TX_DTX_IDX0);


	if(temp == (tx_cpu_owner_idx0+1) % NUM_TX_DESC)
	{
		puts(" @ ");
		goto Done;
	}

	#ifdef RT2880_DUPLICATE_TX_RING

	if(tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 1 && tx_ring1[tx_cpu_owner_idx1].txd_info2.DDONE_bit == 1)
	{


	  if(tingx_is_free == 0 )
	  {
	  	//printf("\n Sent packet with ring1\n");
	  	tingx_is_free = 1;
	  }
	  else
	  {
	  	//printf("\n Sent packet with ring0\n");
	  	tingx_is_free = 0;
	  }


	}
	else if(tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit == 1)
	{
		//printf("\n Sent packet with ring0\n");
	    tingx_is_free = 0;
	}
	else
	{
		//printf("\n Sent packet with ring1\n");
	    tingx_is_free = 1;
	}

	if(force_queue_n == 0)
	{
	  	//printf("\n Force Sent packet with ring0\n");
	  	tingx_is_free = 0;
	}
	else if (force_queue_n == 1)
	{
		//printf("\n Force Sent packet with ring1\n");
	  	tingx_is_free = 1;

	}

	#endif //RT2880_DUPLICATE_TX_RING

	#ifdef RT2880_MUTI_TX_DESCRIPTOR
	//printf(" Send's Packet addr= 0x%08X,Total length=%d \n",packet,length);
	#ifdef RT2880_DUPLICATE_TX_RING
	if(tingx_is_free == 0)
	{
		txd_info = (u32 *)&tx_ring0[tx_cpu_owner_idx0].txd_info2;
		*txd_info = 0;


		bk_len = (length >> 2);

		length = length - (bk_len * 3);

		//Segment 0
		tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
		tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0 = bk_len;
		//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0=%08X",tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0);
		//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0=%d",tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0);

		sdp1_seg_p = packet;
		sdp1_seg_p += bk_len;
    	//Segment 1
		tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1 = bk_len;

		//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1=%08X",tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1);
		//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1=%d",tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1);


		sdp1_seg_p += bk_len;
    	//Segment 2
		tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0 = bk_len;
		//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0=%08X",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0);
		//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0=%d",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0);


		sdp1_seg_p += bk_len;


		//Segment 3
		tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1 = length;

		//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1=%08X",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1);
		//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1=%d",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1);

	}
	else
	{
		txd_info = (u32 *)&tx_ring1[tx_cpu_owner_idx1].txd_info2;
		*txd_info = 0;


		bk_len = (length >> 2);

		length = length - (bk_len * 3);

		//Segment 0
		tx_ring1[tx_cpu_owner_idx1].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
		tx_ring1[tx_cpu_owner_idx1].txd_info2.SDL0 = bk_len;
		//printf("\n tx_ring1[tx_cpu_owner_idx0].txd_info1.SDP0=%08X",tx_ring1[tx_cpu_owner_idx0].txd_info1.SDP0);
		//printf("\n tx_ring1[tx_cpu_owner_idx0].txd_info2.SDL0=%d",tx_ring1[tx_cpu_owner_idx0].txd_info2.SDL0);

		sdp1_seg_p = packet;
		sdp1_seg_p += bk_len;
    	//Segment 1
		tx_ring1[tx_cpu_owner_idx1].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring1[tx_cpu_owner_idx1].txd_info2.SDL1 = bk_len;

		//printf("\n tx_ring1[tx_cpu_owner_idx0].txd_info3.SDP1=%08X",tx_ring1[tx_cpu_owner_idx0].txd_info3.SDP1);
		//printf("\n tx_ring1[tx_cpu_owner_idx0].txd_info2.SDL1=%d",tx_ring1[tx_cpu_owner_idx0].txd_info2.SDL1);


		sdp1_seg_p += bk_len;
    	//Segment 2
		tx_ring1[tx_cpu_owner_idx1 + 1].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring1[tx_cpu_owner_idx1 + 1].txd_info2.SDL0 = bk_len;
		//printf("\n tx_ring1[tx_cpu_owner_idx0 + 1].txd_info1.SDP0=%08X",tx_ring1[tx_cpu_owner_idx0 + 1].txd_info1.SDP0);
		//printf("\n tx_ring1[tx_cpu_owner_idx0 + 1].txd_info2.SDL0=%d",tx_ring1[tx_cpu_owner_idx0 + 1].txd_info2.SDL0);


		sdp1_seg_p += bk_len;


		//Segment 3
		tx_ring1[tx_cpu_owner_idx1 + 1].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
		tx_ring1[tx_cpu_owner_idx1 + 1].txd_info2.SDL1 = length;

		//printf("\n tx_ring1[tx_cpu_owner_idx0 + 1].txd_info3.SDP1=%08X",tx_ring1[tx_cpu_owner_idx0 + 1].txd_info3.SDP1);
		//printf("\n tx_ring1[tx_cpu_owner_idx0 + 1].txd_info2.SDL1=%d",tx_ring1[tx_cpu_owner_idx0 + 1].txd_info2.SDL1);

	}
	#else // Non RT2880_DUPLICATE_TX_RING

	txd_info = (u32 *)&tx_ring0[tx_cpu_owner_idx0].txd_info2;
	*txd_info = 0;


	bk_len = (length >> 2);

	length = length - (bk_len * 3);

	//Segment 0
	tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
	tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0 = bk_len;
	//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0=%08X",tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0);
	//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0=%d",tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0);

	sdp1_seg_p = packet;
	sdp1_seg_p += bk_len;
    //Segment 1
	tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
	tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1 = bk_len;

	//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1=%08X",tx_ring0[tx_cpu_owner_idx0].txd_info3.SDP1);
	//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1=%d",tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL1);


	sdp1_seg_p += bk_len;
    //Segment 2
	tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
	tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0 = bk_len;
	//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0=%08X",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info1.SDP0);
	//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0=%d",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL0);


	sdp1_seg_p += bk_len;


	//Segment 3
	tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1 = cpu_to_le32(phys_to_bus((u32) sdp1_seg_p));
	tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1 = length;

	//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1=%08X",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info3.SDP1);
	//printf("\n tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1=%d",tx_ring0[tx_cpu_owner_idx0 + 1].txd_info2.SDL1);

	#endif //RT2880_DUPLICATE_TX_RING

	#else //Non RT2880_MUTI_TX_DESCRIPTOR
    #ifdef RT2880_DUPLICATE_TX_RING
	if(tingx_is_free == 0)
	{
		tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
		tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0 = length;
	}
	else
	{
		tx_ring1[tx_cpu_owner_idx1].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
		tx_ring1[tx_cpu_owner_idx1].txd_info2.SDL0 = length;
	}
	#else // Non RT2880_DUPLICATE_TX_RING
	tx_ring0[tx_cpu_owner_idx0].txd_info1.SDP0 = cpu_to_le32(phys_to_bus((u32) packet));
	tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0 = length;

	//printf("\n tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0 =%d \n",tx_ring0[tx_cpu_owner_idx0].txd_info2.SDL0);
    #endif //RT2880_DUPLICATE_TX_RING
    #endif //RT2880_MUTI_TX_DESCRIPTOR

	#ifdef RT2880_DUPLICATE_TX_RING
	if(tingx_is_free == 0)
	{
		#ifdef RT2880_MUTI_TX_DESCRIPTOR

		tx_ring0[tx_cpu_owner_idx0 +1 ].txd_info2.LS1_bit = 1;
	 	tx_ring0[tx_cpu_owner_idx0 +1 ].txd_info2.DDONE_bit = 0;
		tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit = 0;
		status = length;


    	tx_cpu_owner_idx0 = (tx_cpu_owner_idx0+2) % NUM_TX_DESC;

    	OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx0), RT2880_TX_CTX_IDX0);


		#else

		tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit = 0;

		status = length;
    	tx_cpu_owner_idx0 = (tx_cpu_owner_idx0+1) % NUM_TX_DESC;
	   	OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx0), RT2880_TX_CTX_IDX0);
		//printf("\RT2880_TX_CTX_IDX0 = %08X \n",INL(dev,RT2880_TX_CTX_IDX0));
		//printf("\RT2880_TX_DTX_IDX0 = %08X \n",INL(dev,RT2880_TX_DTX_IDX0));
		#endif //RT2880_MUTI_TX_DESCRIPTOR

	}
	else
	{

	   	#ifdef RT2880_MUTI_TX_DESCRIPTOR
		tx_ring1[tx_cpu_owner_idx1 +1 ].txd_info2.LS1_bit = 1;
	 	tx_ring1[tx_cpu_owner_idx1 +1 ].txd_info2.DDONE_bit = 0;
		tx_ring1[tx_cpu_owner_idx1].txd_info2.DDONE_bit = 0;
		status = length;


    	tx_cpu_owner_idx1 = (tx_cpu_owner_idx1+2) % NUM_TX_DESC;

    	OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx1), RT2880_TX_CTX_IDX1);


		#else
		tx_ring1[tx_cpu_owner_idx1].txd_info2.DDONE_bit = 0;
		status = length;
    	tx_cpu_owner_idx1 = (tx_cpu_owner_idx1+1) % NUM_TX_DESC;
	    OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx1), RT2880_TX_CTX_IDX1);

		//printf("\RT2880_TX_CTX_IDX1 = %08X \n",INL(dev,RT2880_TX_CTX_IDX1));
		//printf("\RT2880_TX_DTX_IDX1 = %08X \n",INL(dev,RT2880_TX_DTX_IDX1));

		#endif //RT2880_MUTI_TX_DESCRIPTOR
	}
	#else // Non RT2880_DUPLICATE_TX_RING

	#ifdef RT2880_MUTI_TX_DESCRIPTOR

    tx_ring0[tx_cpu_owner_idx0 +1 ].txd_info2.LS1_bit = 1;
	 tx_ring0[tx_cpu_owner_idx0 +1 ].txd_info2.DDONE_bit = 0;
	tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit = 0;
	status = length;


    tx_cpu_owner_idx0 = (tx_cpu_owner_idx0+2) % NUM_TX_DESC;

    OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx0), RT2880_TX_CTX_IDX0);


	#else // Non RT2880_MUTI_TX_DESCRIPTOR
	tx_ring0[tx_cpu_owner_idx0].txd_info2.DDONE_bit = 0;
	status = length;

	if(loopback_protect == 1)
	{
		BUFFER_ELEM *buf;


		buf = rt2880_free_buf_entry_dequeue(&rt2880_busing_buf_list);
		//while
		while(buf != NULL)
		{

			//printf("\n check to Bufnum[%d] \n",RT2880_FREEBUF_OFFSET(buf->pbuf));


			if(tx_ring0[buf->tx_idx].txd_info2.DDONE_bit == 1)
			{
				//printf("\n Precedent of Packet was  send  \n");
				rt2880_free_buf_entry_enqueue(&rt2880_free_buf_list,buf);

			}
			else
			{
				printf("\n Precedent of Packet was pending !!  \n");
				rt2880_free_buf_entry_enqueue(&rt2880_busing_buf_list,buf);
			}
			buf = rt2880_free_buf_entry_dequeue(&rt2880_busing_buf_list);

		}



		i = RT2880_FREEBUF_OFFSET(packet);

		rt2880_free_buf[i].tx_idx = tx_cpu_owner_idx0;
		rt2880_free_buf_entry_enqueue(&rt2880_busing_buf_list,&rt2880_free_buf[i]);

		//printf("\n Loopback Send Bufnum = %d\n",i);


	}


    tx_cpu_owner_idx0 = (tx_cpu_owner_idx0+1) % NUM_TX_DESC;

    OUTL(dev, cpu_to_le32((u32) tx_cpu_owner_idx0), RT2880_TX_CTX_IDX0);

	#endif //RT2880_MUTI_TX_DESCRIPTOR

	#endif //RT2880_DUPLICATE_TX_RING

	//kaiker_led_tx_ring();

	return status;
Done:

	udelay(500);
	retry_count++;

	goto Retry;
}




static int rt2880_eth_recv(struct eth_device* dev)
{
	s32		status;
	int		length = 0,hdr_len=0,bb,i;
    volatile  u32  kk;
    int inter_loopback_cnt =0;
	u32 *rxd_info;
	ulong start_t;
	char lastcommand[30];

	uchar *scatter_src,*scatter_dst;

	start_t = get_timer(0);

	for (; ; ) {
#if 1
		bb = kaiker_button_p();
		if(bb == 3 )
		{
			//kaiker_debug_show(dev);
			input_value(lastcommand);
			kaiker_run_command(lastcommand,0);
		}
#endif

		rxd_info	= &rx_ring[rx_dma_owner_idx0].rxd_info2;
		if ( (*rxd_info & RT2880_BIT(31)) == 0 )
		{
			hdr_len =0;
			if(eth_loopback_mode == 1)
			{
				if (bb == 1)
				{
					rt2880_eth_halt(rt2880_pdev);
					puts ("\nAbort Loopback Mode\n");
					eth_loopback_mode = 0;
					//rt2880_eth_setup(rt2880_pdev);
					return (0);
			    }
		    	continue;
			}
			else
			{
				break;
			}
		}

		udelay(1);

		if(header_payload_scatter_en == ENABLE)
		{
			length = rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN1;
			hdr_len = rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0;
		}
		else
			length = rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0;

		if(header_payload_scatter_en == DISABLE && length == 0)
		{
			printf("\n Warring!! Packet Length has error !!,In normal mode !\n");
		}
		if(header_payload_scatter_en == ENABLE && hdr_len == 0)
		{
			printf("\n Warring!! Packet Length has error !!,In Scatter mode !\n");
		}

	#if 0
		while(length == 0)
		{
			length = rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0;
			if(length != 0)
			{
				printf("\n Warring!! Header length > Payload length!!rxd_info2.PLEN=%d ,start_t=%ld\n",length,get_timer(0));
			}
			if(get_timer(start_t) > CFG_FLASH_STATE_DISPLAY_TOUT)
			{
				printf("\n kaiker!!!! rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN=%d\n",rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0);
				return (0);
			}
		}
	#endif
#ifdef DEBUG
		printf("%s: Rcv the packet,that addr=[0x%08X] \n", __FUNCTION__, NetRxPackets[rx_dma_owner_idx0]);
#endif
		if(eth_loopback_mode == 1)
		{
			if(header_payload_scatter_en == ENABLE)
			{
            //	printf("\n ===== Header len [%d] === \n",hdr_len);
				scatter_dst = (uchar *)KSEG1ADDR(pkthdrbuf[rx_dma_owner_idx0]);
				//scatter_dst[0]=0x00;
				//scatter_dst[1]=0x11;
				//scatter_dst[2]=0x22;
				//scatter_dst[3]=0x33;
				//scatter_dst[4]=0x44;
				//scatter_dst[5]=0x55;
		    	//print_packet(scatter_dst,hdr_len);
			//	printf("\n ===== Pay load len [%d] === \n",length);
				scatter_src = (uchar *)KSEG1ADDR(NetRxPackets[rx_dma_owner_idx0]);
				//print_packet(scatter_src,length);

				scatter_dst += hdr_len;

				memcpy(scatter_dst,scatter_src,length);

	        	length += hdr_len;

				rt2880_eth_send(dev, (void *)KSEG1ADDR(pkthdrbuf[rx_dma_owner_idx0]),length);
			}
			else
			{
				BUFFER_ELEM *buf;

				buf = rt2880_free_buf_entry_dequeue(&rt2880_free_buf_list);

				if(buf == NULL)
				{
					printf("\n Warrng Packet Buffer is Empty!!\n");
					return (0);
				}
				//printf("\n Ready loopback,Current Buff num = %d \n",RT2880_FREEBUF_OFFSET(NetRxPackets[rx_dma_owner_idx0]));

				loopback_protect = 1;
				rt2880_eth_send(dev, (void *)KSEG1ADDR(NetRxPackets[rx_dma_owner_idx0]),length);
				loopback_protect = 0;
				NetRxPackets[rx_dma_owner_idx0] = buf->pbuf;

				rx_ring[rx_dma_owner_idx0].rxd_info2.LS0= 1;
				rx_ring[rx_dma_owner_idx0].rxd_info1.PDP0 = cpu_to_le32(phys_to_bus((u32) NetRxPackets[rx_dma_owner_idx0]));
			}
		}
		else
		{
			if(header_payload_scatter_en == ENABLE)
			{
				scatter_dst = (uchar *)KSEG1ADDR(pkthdrbuf[rx_dma_owner_idx0]);

				scatter_src = (uchar *)KSEG1ADDR(NetRxPackets[rx_dma_owner_idx0]);

				scatter_dst += hdr_len;

				memcpy(scatter_dst,scatter_src,length);
				length += hdr_len;
				if(rx_ring[rx_dma_owner_idx0].rxd_info4.SP == 0)
				{// Packet received from CPU port
					//printf("\n HEADER_PAYLOAD_SCATTER mode,Packet received from CPU port,plen=%d \n",length);
					//print_packet((void *)KSEG1ADDR(pkthdrbuf[rx_dma_owner_idx0]),length);
					inter_loopback_cnt++;
					length = inter_loopback_cnt;//for return
				}
				else
		    		NetReceive((void *)KSEG1ADDR(pkthdrbuf[rx_dma_owner_idx0]), length );
		    	/* added by Leo, 2007/08/01 12:59:47 */
		    	puts(">");
		    	/* ********************************* */
			//kaiker_led_scatter_packet();
			}
			else
			{
				if(rx_ring[rx_dma_owner_idx0].rxd_info4.SP == 0)
				{// Packet received from CPU port
					//printf("\n Normal Mode,Packet received from CPU port,plen=%d \n",length);
					//print_packet((void *)KSEG1ADDR(NetRxPackets[rx_dma_owner_idx0]),length);
					inter_loopback_cnt++;
					length = inter_loopback_cnt;//for return
				}
				else
		    		NetReceive((void *)KSEG1ADDR(NetRxPackets[rx_dma_owner_idx0]), length );
				/* added by Leo, 2007/08/01 12:59:47 */
		    	puts(">");
		    	/* ********************************* */
			}

		}

		#if 0
		rx_ring[rx_dma_owner_idx0].rxd_info2.DDONE_bit = 0;
		rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN = 0;
		#else
		rxd_info = (u32 *)&rx_ring[rx_dma_owner_idx0].rxd_info4;
		*rxd_info = 0;
		rxd_info = (u32 *)&rx_ring[rx_dma_owner_idx0].rxd_info2;
		*rxd_info = 0;
		#endif

		/* Tell the adapter where the TX/RX rings are located. */
  	    OUTL(dev, phys_to_bus((u32) &rx_ring[0]), RT2880_RX_BASE_PTR0);

		//udelay(10000);
		/*  Move point to next RXD which wants to alloc*/
		OUTL(dev, cpu_to_le32((u32) rx_dma_owner_idx0), RT2880_RX_CALC_IDX0);

		/* Update to Next packet point that was received.
		 */
		rx_dma_owner_idx0 = (rx_dma_owner_idx0 + 1) % NUM_RX_DESC;

		//printf("\n ************************************************* \n");
		// printf("\n RT2880_RX_CALC_IDX0=%d \n", INL(dev,RT2880_RX_CALC_IDX0));
        // printf("\n RT2880_RX_DRX_IDX0 = %d \n",INL(dev,RT2880_RX_DRX_IDX0));
		//printf("\n ************************************************* \n");
	}
	return length;
}

void rt2880_eth_halt(struct eth_device* dev)
{
	u32	regValue;

	STOP_RT2880_ETH(dev);

	gmac_phy_switch_gear(DISABLE);

	puts(" STOP_RT2880_ETH \n");

	//dump_reg();
}


void kaiker_debug_show(struct eth_device* dev)
{
	int		kk;

#if 1
			printf("\n# rx_ring[rx_dma_owner_idx0].rxd_info2.DDONE_bit=%d ,length=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info2.DDONE_bit,rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0);
			printf("#rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.IPFVLD_bit=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.IPFVLD_bit);
			rx_ring[rx_dma_owner_idx0].rxd_info4.IPFVLD_bit=0;
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.L4FVLD_bit=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.L4FVLD_bit);
			rx_ring[rx_dma_owner_idx0].rxd_info4.L4FVLD_bit=0;
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.IPF=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.IPF);
			rx_ring[rx_dma_owner_idx0].rxd_info4.IPF = 0;
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.L4F=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.L4F);
			rx_ring[rx_dma_owner_idx0].rxd_info4.L4F =0;
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.AIS=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.AIS);
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.AI=%02X \n",rx_ring[rx_dma_owner_idx0].rxd_info4.AI);
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.FVLD=%d \n",rx_ring[rx_dma_owner_idx0].rxd_info4.FVLD);
			printf("\n #rx_ring[rx_dma_owner_idx0].rxd_info2.rxd_info4.FOE_Entry=%04X \n",rx_ring[rx_dma_owner_idx0].rxd_info4.FOE_Entry);

#endif

				#if 1
				for(kk=0;kk<NUM_RX_DESC;kk++)
				{
					printf("\n rx_ring[%d].rxd_info2.DDONE_bit=%d \n",kk,rx_ring[kk].rxd_info2.DDONE_bit);
					printf("\n rx_ring[%d].rxd_info2.PLEN=%d \n",kk,rx_ring[kk].rxd_info2.PLEN0);


				}
				for(kk=0;kk<NUM_RX_DESC;kk++)
				{
					printf("\n tx_ring0[%d].txd_info2.DDONE_bit=%d \n",kk,tx_ring0[kk].txd_info2.DDONE_bit);



				}
				#endif
				printf("\n ############################ \n");



                  kk = INL(dev, RT2880_PDMA_GLO_CFG);
				  if((kk & RT2880_RX_DMA_BUSY))
				  printf("\n  RT2880_RX_DMA_BUSY !!! ");
				  if((kk & RT2880_TX_DMA_BUSY))
				 printf("\n  RT2880_TX_DMA_BUSY !!! ");


				  kk = INL(dev, RT2880_FE_INT_STATUS);

				  OUTL(dev, cpu_to_le32((u32) kk), RT2880_FE_INT_STATUS);


				  printf("\n print RT2880_FE_INT_STATUS content=[0x%08X]\n",kk);

				  if((kk & RT2880_CNT_PPE_AF))
				  printf("\n PPE Counter Table Almost Full ");

				  if((kk & RT2880_CNT_GDM1_AF))
				  printf("\n GDMA1 Counter Table Almost Full ");

				  if((kk & RT2880_PSE_P1_FC))
				  printf("\n PSE port1 (GDMA1) flow control asserted. ");

				   if((kk & RT2880_PSE_P0_FC))
				  printf("\n PSE port0 (CDMA) flow control asserted. ");

				   if((kk & RT2880_TX_COHERENT))
				  printf("\n RT2880_TX_COHERENT ");

				   if((kk & RT2880_RX_COHERENT))
				  printf("\n RT2880_RX_COHERENT ");



  			    if((kk & RT2880_PSE_FQ_EMPTY))
				  printf("\n PSE free Q empty threshold reached & forced  ");

				 if((kk & RT2880_GE1_STA_CHG))
				  printf("\n GE port #1 link status changes (link, speed, flow control)  ");

				  if((kk & RT2880_TX_DONE_INT1))
				  printf("\n High priority packet transmit interrupt  ");

				   if((kk & RT2880_TX_DONE_INT0))
				  printf("\n Low priority packet transmit interrupt  ");

				    if((kk & RT2880_RX_DONE_INT0))
				  printf("\n Packet receive interrupt.  ");

				  if((kk & RT2880_RX_DLY_INT))
				  printf("\n Delayed version of RX_DONE_INT0.  ");

				  if((kk & RT2880_TX_DLY_INT))
				  printf("\n Delayed version of TX_DONE_INT0 and TX_DONE_INT1.  ");

				  printf("\n\n");






				  printf("\n RT2880_RX_CALC_IDX0=%d \n", INL(dev,RT2880_RX_CALC_IDX0));
           		  printf("\n RT2880_RX_DRX_IDX0 = %d \n",INL(dev,RT2880_RX_DRX_IDX0));



				printf("\n rx_ring[%d].rxd_info2.PLEN=%d \n",rx_dma_owner_idx0,rx_ring[rx_dma_owner_idx0].rxd_info2.PLEN0 );

				printf("\n RT2880_TX_CTX_IDX0 = %08X \n",INL(dev,RT2880_TX_CTX_IDX0));
				printf("\n RT2880_TX_DTX_IDX0 = %08X \n",INL(dev,RT2880_TX_DTX_IDX0));


				printf("\n RT2880_TX_CTX_IDX1 = %08X \n",INL(dev,RT2880_TX_CTX_IDX1));
				printf("\n RT2880_TX_DTX_IDX1 = %08X \n",INL(dev,RT2880_TX_DTX_IDX1));



				printf("\n ############################ \n");





}

#if 0
static void print_packet( u8 * buf, int length )
{
	int i;
	int remainder;
	int lines;

	printf("Packet of length %d \n", length );

	lines = length / 16;
	remainder = length % 16;

	for ( i = 0; i < lines ; i ++ ) {
		int cur;

		for ( cur = 0; cur < 8; cur ++ ) {
			u8 a, b;

			a = *(buf ++ );
			b = *(buf ++ );
			printf("%02X %02X ", a, b );
		}
		printf("\n");
	}
	for ( i = 0; i < remainder/2 ; i++ ) {
		u8 a, b;

		a = *(buf ++ );
		b = *(buf ++ );
		printf("%02X %02X ", a, b );
	}
	printf("\n");

}
#endif

#define PSRC_ADDR      0x8a1312ff
#define PDEST_ADDR      0x8b131247
#define PDEST_ADDR1     0x8a731247
#define MEM_SIZE        65535
#define RUN		1
#define MEMTEST 1

/* bob added ++*/
// #define SDRAM_BASE_MEMTEST 0x8a800000
// #define SDRAM_BASE1_MEMTEST 0xaa900000
#define SDRAM_BASE_MEMTEST  0x8b000000
#define SDRAM_BASE1_MEMTEST 0xab00000
#define SRAM_BASE_MEMTEST   0xa0900000
#define SIZE_OF_SRAM (32*1024)

#define TEST_SIZE SIZE_OF_SRAM

#define SRAM_TEST_SIZE (10240)

#define TEST_SIZE_OF_SDRAM (6*1024*1024)

#define MEMTEST_BLOCK_SIZE		(4*1024)

/* bob ++ */
#define    ESRAM    1
void test_random(u32 k) // unused part, legacy code
{
    int i;
    unsigned char *src,*dest;
    unsigned int mem_test_size, sram_mem_offset, sdram_mem_offset;
 unsigned int random_i;


    //srandom(time(0) | getpid());

#if 0

  for ( i = 0; i < k; i++)
  {
  //printf("\n Total Test num [%d]\n",i);
 if(kaiker_button_p())
 {
    printf("\n Abort memtest!!\n");
   return;

 }
 random_i = (unsigned int)get_timer(0);

  /* step 1: decide memory size */
 mem_test_size = (random_i % SIZE_OF_SRAM);

 /* step 2: decide sram offset */
 sram_mem_offset = (random_i % (SIZE_OF_SRAM-mem_test_size));

 /* step 3: decide sdram offset */
 sdram_mem_offset = (random_i % (SIZE_OF_SDRAM-mem_test_size));

 src = (SDRAM_BASE_MEMTEST + sdram_mem_offset);
 dest = (SRAM_BASE_MEMTEST + sram_mem_offset);

 if(random_memcpy(dest,src,mem_test_size))
 {
    udelay(mem_test_size);
    continue;
 }

 random_memcpy(src,dest,mem_test_size);
 udelay(mem_test_size);
 printf("\nTest Count[%d]\n",i+1);
  } /* for */
#endif
}

void sram_test_random(u32 test_times)
{
    int i;
    unsigned char *src,*dest;
    unsigned int mem_test_size, src_mem_offset, dest_mem_offset;
    unsigned int random_i, i_diff;


  for ( i = 0; i < test_times; i++)
  {
  //printf("\n Total Test num [%d]\n",i);
   if(kaiker_button_p())
   {
    printf("\n Abort memtest!!\n");
   return;

   }

memtest_sram_reset:
   random_i = (unsigned int)get_timer(0);


  /* step 1: decide memory size */
  mem_test_size = (random_i % SRAM_TEST_SIZE);

  /* step 2: decide source sram offset */
  src_mem_offset = (random_i % (SIZE_OF_SRAM-mem_test_size));

  /* step 3: decide dest sram offset */
  random_i = (unsigned int)get_timer(random_i);
  dest_mem_offset = (random_i % (SIZE_OF_SRAM-mem_test_size));

  if (src_mem_offset == dest_mem_offset)
	goto memtest_sram_reset;


  if ( src_mem_offset > dest_mem_offset)
   i_diff = src_mem_offset - dest_mem_offset;
  else
   i_diff = dest_mem_offset - src_mem_offset;

  if (i_diff < mem_test_size)
	goto memtest_sram_reset;



 src = src_mem_offset + SRAM_BASE_MEMTEST;
 dest = dest_mem_offset + SRAM_BASE_MEMTEST;


 random_memcpy(src,dest,mem_test_size);

 udelay(mem_test_size);

 printf("\nTest Count[%d]\n",i);
  } /* for */
}

int address_check(unsigned int src, unsigned int dest, unsigned int size)
{
	unsigned int offset;

	if ( src == dest )
		return 0;

	if ( src > dest )
		offset = src - dest;
	else
		offset = dest - src;

	if ( offset < size )
		return 0;

	return 1;
}

int ram_test_random(u32 test_times, u32 mem_base)
{
    int i, result, fail_cnt;
    unsigned char *src,*dest;
    unsigned int mem_test_size, src_mem_offset, dest_mem_offset;
    unsigned int random_i, i_diff;

  fail_cnt = 0;
  for ( i = 0; i < test_times; i++)
  {
  //printf("\n Total Test num [%d]\n",i);
   if(kaiker_button_p())
   {
    	printf("\n--> Run %d test counts ...User Cancel memtest!!\n", i);
   	return;
   }

	do {

		if (kaiker_button_p())
		{
    			printf("\n--> Run %d test counts ...User Cancel memtest!!\n", i);
   			return;
		}

   	  	  random_i = (unsigned int)get_timer(test_times);
		  /* step 1: decide memory size */
		  mem_test_size = (random_i % MEMTEST_BLOCK_SIZE);

		  /* step 2: decide source sdram offset */
		  random_i = (unsigned int)get_timer(random_i);
		  src_mem_offset = (random_i % (TEST_SIZE_OF_SDRAM-mem_test_size));

		  /* step 3: decide dest sdram offset */
		  random_i = (unsigned int)get_timer(random_i);
		  dest_mem_offset = (random_i % (TEST_SIZE_OF_SDRAM-mem_test_size));
	} while (address_check(src_mem_offset, dest_mem_offset, mem_test_size) == 0);


	if ( (i%2) == 0 )  {
    		src = dest_mem_offset + mem_base;
    		dest = src_mem_offset + SDRAM_BASE1_MEMTEST;
	} else {
		src  = src_mem_offset + SDRAM_BASE1_MEMTEST;
    		dest = dest_mem_offset + mem_base;
	}

    	result =  random_memcpy(src,dest,mem_test_size);


    	if(result != 0) {
     		printf("Random Mem Test Count[%d], %d failed\n-------\n\n",i+1, result);
		fail_cnt++;
    	}
    	// udelay(mem_test_size);
  } /* for */
  printf("\nRandom Mem Test Count - %d, %d failed\n",i, fail_cnt);
}

int random_memcpy(unsigned char* p_dest, unsigned char* p_src, unsigned int length)
{
	int i, j, k;
	unsigned char *pSrc = p_src;
	unsigned char *pDest = p_dest;

  if (length > TEST_SIZE_OF_SDRAM)
	return -1;

// printf(" ... memcpy() start...");
 memcpy(pDest, pSrc, length);
// printf("Done\n");

 j = 0;

 for ( i = 0; i < length; i++) {
  if (pDest[i] != pSrc[i]) {
//    printf("data error in pDest[%d], 0x%x[%d] ... pSrc[%d], 0x%x[%d]\n", i, (pDest + i), pDest[i], i, (pSrc + i), pSrc[i]);
  	j++;
  }
    } /* for */

// printf("dest_addr src_addr size : 0x%x 0x%x %d\n\n", pDest, pSrc, length);
//  if ( j == 0)
//  printf("memory test ok!\n\n");
//    else
    	if (j != 0)
    	{
  		printf("src_addr: 0x%x dest_addr: 0x%x size: %d.\n", pSrc, pDest, length);
  // printf("memory test failed!\n\n");
  // while(1);
	}


	return j;
}

#if 0
void rt2880_memory_test(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	 unsigned char *src,*dest;
	 u32 count = 0;
	 int choice;

	 switch (argc) {
   		case 1:
 		    printf("memtest usage :\n%s\n", cmdtp->usage);
		    break;

		case 2:
		     count = simple_strtoul(argv[1], NULL, 10);
		     printf("\n Random Test [%d] times \n",count);
		     ram_test_random(count, SDRAM_BASE_MEMTEST);
		     break;
		case 3:
		    choice = simple_strtoul(argv[1], NULL, 16);
		    count = simple_strtoul(argv[2], NULL, 10);
		    if (choice == 0) {
			  printf("\n error \n");
		    } else if (choice == 1) {
			  /* test sdram */
			  ram_test_random(count, SDRAM_BASE_MEMTEST);
		    }
		    else if (choice == 2)
		    {
			  /* test sram */
			  ram_test_random(count, SRAM_BASE_MEMTEST);
 		    }
		    break;
		case 4:
			 src = simple_strtoul(argv[1], NULL, 16);
			 dest = simple_strtoul(argv[2], NULL, 16);
			 count = simple_strtoul(argv[3], NULL, 10);
			 random_memcpy(dest,src,count);
			 break;
		default:
			 printf("memtest input cmd error!");
			 break;

	};

	return;
}

U_BOOT_CMD(
 	memtest,	4,	1,	rt2880_memory_test,
 	"memtest   - Ralink memory test !!\n",
 	"memtest [Run Count]  -  Memory test with random's addr and random's size !!\n"
	"memtest [src address] [dest address] [test size]-  Memory test with assign's addr and assign's size !!\n"


);
#endif

#if 0
void rt2880_memory_test_extra_arg(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if (strcmp(argv[1], "esram") == 0)
	{
		if(strcmp(argv[2], "on") == 0)
	    {

			rt2880_esram_gear = RT2880_ESRAM_ON;
			printf("\n RT2880 Memory Test ESRAM enable ! \n");
			return;
		}
		else if(strcmp(argv[2], "off") == 0)
		{
			rt2880_esram_gear = RT2880_ESRAM_OFF;
			printf("\n RT2880 Memory Test ESRAM disable ! \n");
			return;
		}
	}
	else if (strcmp(argv[1], "fixsize") == 0)
	{
		rt2880_size_of_mem = simple_strtoul(argv[2], NULL, 10);

		printf("\n Memory Test size = %d\n",rt2880_size_of_mem);
	}
}

U_BOOT_CMD(
 	marg,	4,	1,	rt2880_memory_test_extra_arg,
 	"marg   - Ralink memory test !!\n",
 	"marg esram on/off  -    !!\n"
	"marg fixsize [size],if size = 0 then disable fixsize-  Memory test with fix size !!\n"
);
#endif

#if 0
void do_eth_loopback(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	   //printf("\n do_eth_loopback is called ! \n");


	  if(eth_loopback_mode)
	  {
		eth_loopback_mode=0;

		printf("\n Set to Normal mode ! \n");
	  }
	  else
	  {
		eth_loopback_mode=1;
		printf("\n Set to LoopBack mode ! \n");
	  }



       return ;
}


U_BOOT_CMD(
 	loopback,	1,	1,	do_eth_loopback,
 	"loopback   - Ralink eth loopback test !!\n",
 	"kaiker,loopback   - Ralink eth loopback test !!\n"
);
#endif

void rt2880_pse_reset(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	RESET_RT2880_ETH(rt2880_pdev);

	printf("\n\n\n*********************** PSE Reset !! \n\n\n");
}

U_BOOT_CMD(
 	pse_reset,	1,	1,	rt2880_pse_reset,
 	"pse_reset  !!\n",
 	"pse_reset, !!\n"
);

void rt2880_debug_show(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	kaiker_debug_show(rt2880_pdev);
	STOP_RT2880_ETH(rt2880_pdev);
	puts(" STOP_RT2880_ETH \n");
}
U_BOOT_CMD(
 	sdd,	1,	1,	rt2880_debug_show,
 	"sdd   - Display to all DMA status  !!\n",
 	"kaiker,sdd   - !!\n"
);




/*
	FUNCTION: ConvertCharToHex
	PURPOSE:   Convert string to hex
*/

void ConvertCharToHex(char *s,u32 *d1)
{
	int i;
	char chr;

	*d1=0;
	for (i=0; i < strlen(s); i++)
	{
        *d1 = *d1 * 16;
        chr = s[i];
        if (chr >= '0' && chr <= '9')
            *d1 += chr - '0';
        else if (chr >= 'a' && chr <= 'f')
            *d1 += chr - 'a' + 10;
        else if (chr >= 'A' && chr <= 'F')
            *d1 += chr - 'A' + 10;

	}


}

static inline u32 byte_transpose(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & 0x000000FF;
		return v;
		case 1:
		v= v & 0x000000FF;
		v = v << 8;
		return v;
		case 2:
		v= v & 0x000000FF;
		v = v << 16;
		return v;
		case 3:
		v= v & 0x000000FF;
		v = v << 24;
		return v;
	}
}

static inline u8 byte_select(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & 0x000000FF;
		return (u8)v;
		case 1:
		v = v & 0x0000FF00;
		v = v >> 8;
		return (u8)v;
		case 2:
		v = v & 0x00FF0000;
		v = v >> 16;
		return (u8)v;
		case 3:
		v = v & 0xFF000000;
		v = v >> 24;
		return (u8)v;
	}
}
static inline u32 halfword_transpose(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & 0x0000FFFF;
		return v;

		case 2:
		v= v & 0x0000FFFF;
		v = v << 16;
		return v;

	}
}
static inline u16 halfword_select(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & 0x0000FFFF;
		return (u16)v;
		case 2:
		v = v & 0xFFFF0000;
		v = v >> 16;
		return (u16)v;

	}
}
static inline u32 halfword_mask(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & 0xFFFF0000;
		break;
		case 2:
		v = v & 0x0000FFFF;

		break;

	}
	return v;
}

static inline u32 byte_mask(int n,u32 v)
{
	switch(n)
	{
		case 0:
		v= v & ~0x000000FF;
		break;
		case 1:
		v = v & ~0x0000FF00;

		break;
		case 2:
		v = v & ~0x00FF0000;

		break;
		case 3:
		v = v & ~0xFF000000;

		break;
	}
	return v;
}


//---------------------------------------------------------------------------------------------
// Function Name: MemBaseTest_8139_Byte
// Description: Byte read
//---------------------------------------------------------------------------------------------
#ifdef RT2880_PCI_0310
int MemBaseTest_8139_Byte(u32 iobase,u32 offset,u8 RW,u8 BW)
{
    u8  RTL8139_value_b,ii,fail_num=0;
    u32  WriteValue,ReadValue;
    u16 halfwordvalue;
    u32 WriteValue_dw;
    u32 TestValue;
    u32 old_value,new_value,reg_ar;
    u16 RTL8139_value_w;
    u32 RTL8139_value_Dw;
	u32 memwinbase = PCI_ALLOCATE_SPACE;
    char  writestr[10];
    int byte_offset,halfword_offset;
    int ReturnValue;
	u8 byte;

    TestValue=0x5A5A00BC;

    //Test Register TSAD0~3


	printf("\n iobase = 0x%08X \n",iobase);

	printf("\n old,offset = 0x%X\n",offset);

	memwinbase = memwinbase + ((offset >> 5) << 5);

	printf("\n memwinbase = 0x%08X \n",memwinbase);



	PCI_MEMBASE = memwinbase;
	//PCI_IOBASE = memwinbase;

	udelay(50000);

	offset = offset % 32;
	byte_offset = offset & 0x3;
	halfword_offset = offset & 0x2;
	offset = offset & 0xFFFFFFFC;

	printf("\n new,offset = 0x%X\n",offset);

	switch(BW)
	{
	case 1: /*byte size read/write*/
		/*-----------------------*/

		switch(RW)
		{
		case 1:/*Byte Read/Write*/

	       ReadValue = PCI_MEMWIN(offset);
			byte = byte_select(byte_offset,ReadValue);
		   	printf("\n kaiker,phy addr=%08X, Read value=%02X\n",memwinbase+offset ,byte);
		      	break;
		case 2:/*Byte write*/

			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);

			WriteValue = byte_transpose(byte_offset,WriteValue);
			printf("\n WriteValue = %08X ,after byte_transpose\n",WriteValue);
            ReadValue = PCI_MEMWIN(offset);
			printf("\n ReadValue = %08X\n",ReadValue);
			ReadValue = byte_mask(byte_offset,ReadValue);

			printf("\n ReadValue= %08X ,after byte_mask\n",ReadValue);
			WriteValue = WriteValue | ReadValue;
			printf("\n willing WriteValue= %08X ,after byte_mask\n",WriteValue);

			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);
			byte = byte_select(byte_offset,ReadValue);

	      	printf("\n,phy addr=%08X,Write  value=%02X\n",memwinbase+offset,byte);
		break;

		default:
			return 0;
		}
		/*-----------------------*/
	break;/* case 1  Byte Read/Write*/

	case 2: /*word size read/write*/
		/*-----------------------*/
		switch(RW)
		{
		case 1:/*Word Read*/
			   ReadValue = PCI_MEMWIN(offset);
	      		ReadValue = halfword_select(halfword_offset,ReadValue);
		      	printf("\nReg addr %8x,Read HalfWord value=%04x\n",reg_ar,ReadValue);
		      	break;
		case 2:/*Word write*/
			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);

			WriteValue = halfword_transpose(halfword_offset,WriteValue);
			printf("\n WriteValue = %08X ,after halfword_transpose\n",WriteValue);
            ReadValue = PCI_MEMWIN(offset);
			printf("\n ReadValue = %08X\n",ReadValue);
			ReadValue = halfword_mask(halfword_offset,ReadValue);

			printf("\n ReadValue= %08X ,after halfword_mask\n",ReadValue);
			WriteValue = WriteValue | ReadValue;
			printf("\n willing WriteValue= %08X ,after byte_mask\n",WriteValue);

			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);

			halfwordvalue = halfword_select(halfword_offset,ReadValue);


	      	printf("\n,phy addr=%08X,Write  value=%04X\n",memwinbase+offset,halfwordvalue);
		break;

		default:
			return 0;
		}
	/*-----------------------*/
	break;/*case 2 Dword size read/write*/

	case 3:/*Double word size read/write*/
		/*-----------------------*/
		switch(RW)
		{
		case 1:/*DWord Read*/
			ReadValue = PCI_MEMWIN(offset);

		   	printf("\n kaiker,phy addr=%08X, Read value=%08X\n",memwinbase+offset ,ReadValue);
		   	break;
		case 2:/*DWord write*/
			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);
			printf("\n writestr = %08X \n",WriteValue);



			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);

	      	printf("\n,phy addr=%08X,Write  value=%08X\n",memwinbase+offset,ReadValue);
		break;

		default:
			return 0;
		}
	/*-----------------------*/
	break;/*Double word size read/write */

	}

}
#else
int MemBaseTest_8139_Byte(u32 iobase,u32 offset,u8 RW,u8 BW)
{
    u8  RTL8139_value_b,ii,fail_num=0;
    u32  WriteValue,ReadValue;
    u16 halfwordvalue;
    u32 WriteValue_dw;
    u32 TestValue;
    u32 old_value,new_value,reg_ar;
    u16 RTL8139_value_w;
    u32 RTL8139_value_Dw;

    char  writestr[10];
    int byte_offset,halfword_offset;
    int ReturnValue;
	u8 byte;

    TestValue=0x5A5A00BC;







	udelay(50000);


	byte_offset = offset & 0x3;
	halfword_offset = offset & 0x2;
	offset = offset & 0xFFFFFFFC;

	printf("\n new,offset = 0x%X\n",offset);

	switch(BW)
	{
	case 1: /*byte size read/write*/
		/*-----------------------*/

		switch(RW)
		{
		case 1:/*Byte Read/Write*/

	       ReadValue = PCI_MEMWIN(offset);
			byte = byte_select(byte_offset,ReadValue);
		   	printf("\n kaiker,Read value=%02X\n",byte);
		      	break;
		case 2:/*Byte write*/

			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);

			WriteValue = byte_transpose(byte_offset,WriteValue);
			printf("\n WriteValue = %08X ,after byte_transpose\n",WriteValue);
            ReadValue = PCI_MEMWIN(offset);
			printf("\n ReadValue = %08X\n",ReadValue);
			ReadValue = byte_mask(byte_offset,ReadValue);

			printf("\n ReadValue= %08X ,after byte_mask\n",ReadValue);
			WriteValue = WriteValue | ReadValue;
			printf("\n willing WriteValue= %08X ,after byte_mask\n",WriteValue);

			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);
			byte = byte_select(byte_offset,ReadValue);

	      	printf("\n,Write value=%02X\n",byte);
		break;

		default:
			return 0;
		}
		/*-----------------------*/
	break;/* case 1  Byte Read/Write*/

	case 2: /*word size read/write*/
		/*-----------------------*/
		switch(RW)
		{
		case 1:/*Word Read*/
			   ReadValue = PCI_MEMWIN(offset);
	      		ReadValue = halfword_select(halfword_offset,ReadValue);
		      	printf("\nRead HalfWord value=%04x\n",ReadValue);
		      	break;
		case 2:/*Word write*/
			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);

			WriteValue = halfword_transpose(halfword_offset,WriteValue);
			printf("\n WriteValue = %08X ,after halfword_transpose\n",WriteValue);
            ReadValue = PCI_MEMWIN(offset);
			printf("\n ReadValue = %08X\n",ReadValue);
			ReadValue = halfword_mask(halfword_offset,ReadValue);

			printf("\n ReadValue= %08X ,after halfword_mask\n",ReadValue);
			WriteValue = WriteValue | ReadValue;
			printf("\n willing WriteValue= %08X ,after byte_mask\n",WriteValue);

			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);

			halfwordvalue = halfword_select(halfword_offset,ReadValue);


	      	printf("\nWrite  value=%04X\n",halfwordvalue);
		break;

		default:
			return 0;
		}
	/*-----------------------*/
	break;/*case 2 Dword size read/write*/

	case 3:/*Double word size read/write*/
		/*-----------------------*/
		switch(RW)
		{
		case 1:/*DWord Read*/
			ReadValue = PCI_MEMWIN(offset);

		   	printf("\n Read value=%08X\n",ReadValue);
		   	break;
		case 2:/*DWord write*/
			printf("\n input write value:");

			input_value(writestr);
			ConvertCharToHex(writestr,&WriteValue);
			printf("\n writestr = %08X \n",WriteValue);



			PCI_MEMWIN(offset) = WriteValue;
			udelay(5000);
			ReadValue = PCI_MEMWIN(offset);

	      	printf("\n,Write  value=%08X\n",ReadValue);
		break;

		default:
			return 0;
		}
	/*-----------------------*/
	break;/*Double word size read/write */

	}

}

#endif

void input_value(u8 *str)
{
	while(1)
	{
		if (readline ("==:") > 0)
		{
			strcpy (str, console_buffer);
			break;
		}
		else
			break;
	}
}

void rt2880_pci_scan(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32       ii,jj,aa,kk,kk1,mem_ar,io_ar,offset,reg_offset,setvalue,content;
     u32       cpsr_flags,slot_num,Item;
    char soffset[3],RWselect,BWDselect,str_numeral[3],str_setvalue[10];
	static char lastcommand[CFG_CBSIZE] = { 0, };
    u16 status;
	int len;



	PCI_PCICFG_REG = 0;
	PCI_ARBCTL_REG = 0x79;


	PCI_MEMBASE = PCI_ALLOCATE_SPACE;
	//PCI_IOBASE = memwinbase;

	kaiker_PCI_Scan_Bus_Test();

	//printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));
//	*(volatile u_long *)(0xA0301004) = 0xFFFFFFFF;
	 do
    {
    RETURN_TO_MAIN_MENU:
        printf("------ Test AHB-PCI Bridge ------\n");

        printf("<1>.Two RTL8139D NIC cards Ping Pong Test \n");
     	printf("<2>.Read/Write  REG test \n");
        printf("<0>.Exit...\n");
        printf("*** Please Input the Item <0>~<4>:");

       while((Item = getc())== 0);
        switch(Item)
        {
         /*
               case 1:
                kaiker_PCI_Bridge_Test();
     	        break;

                case 2:
                kaiker_PCI_Scan_Bus_Test();
     		break;

            case 2:
                kaiker_PCI_InitPCIDevice();
     		break;
     	*/



	case '2':

		/*
	 	Ulw.lw = sys_read_pci_config_word(Finded_PCIDeviceID[0].PCIDeviceID, 0x3C);         // read back value
	        printf("\n\n******8139 num1= 0x%02x:0x%02x:0x%02x:0x%02x: ***********\n",Ulw.lw_u8[3],Ulw.lw_u8[2],Ulw.lw_u8[1],Ulw.lw_u8[0]);

	     	Ulw.lw = sys_read_pci_config_word(Finded_PCIDeviceID[1].PCIDeviceID, 0x3C);         // read back value
	        printf("\n\n******8139 num2= 0x%02x:0x%02x:0x%02x:0x%02x: ***********\n",Ulw.lw_u8[3],Ulw.lw_u8[2],Ulw.lw_u8[1],Ulw.lw_u8[0]);

	     	Ulw.lw = sys_read_pci_config_word(Finded_PCIDeviceID[2].PCIDeviceID, 0x3C);         // read back value
	        printf("\n\n******PCI bridge= 0x%02x:0x%02x:0x%02x:0x%02x: ***********\n",Ulw.lw_u8[3],Ulw.lw_u8[2],Ulw.lw_u8[1],Ulw.lw_u8[0]);
     		break;
     		*/
     		 /***************************************/

		GO_BACK:
		printf("\nSelect Device 1.%08x 2.%08x 3.%08x:",Finded_PCIDeviceID[0].dev_ven,Finded_PCIDeviceID[1].dev_ven,Finded_PCIDeviceID[2].dev_ven);
		  while((ii = getc())== 0);
		if(ii> '3')
		{
			printf("\nDevice select error !!\n");
			break;

		}
		ii = ii - 0x30;

                mem_ar = sys_read_pci_config_word(Finded_PCIDeviceID[ii-1].PCIDeviceID, PCI_CSH_BASE_ADDR_REG+0 ); //read back base addr

                io_ar=sys_read_pci_config_word(Finded_PCIDeviceID[ii-1].PCIDeviceID, PCI_CSH_BASE_ADDR_REG+4 ); //read back base addr
		printf("\nSelect  Space 1.MEMORY 2.IO 3.Configuration :");
		 while((jj = getc())== 0);

		if(jj=='1')
		{/*Select memory space*/
			if(mem_ar & 0x00000001)/*BAR0 is IO space*/
				mem_ar=io_ar;
		}
		else if(jj=='2')
		{/*Selece IO space*/
			if(io_ar & 0x00000001)/*BAR1 is IO space*/
				mem_ar=io_ar;

		}
		else if(jj=='3')
		{
		while(1)
		{
		printf("\nSelect Register number and input read /write value\n");
		printf("\nEx: The command register that write 03H: 4w3\n");
		printf("\nEx:  Read Status register :  6r \n");
		printf("\n [ q ] go back  \n");
		printf("\n [ exit ] return to main menu  \n");
		printf(" \n :");
		//scanf("%s",&lastcommand);

		while(1)
		{
			len = readline (":");

			if (len > 0)
			{
				strcpy (lastcommand, console_buffer);
				break;
			}

		}

		if(lastcommand[0]=='q')
		goto GO_BACK;
		if(strcmp(lastcommand,"exit")==0)
		goto RETURN_TO_MAIN_MENU;
		for(kk=0,kk1=0;lastcommand[kk]!=0;kk++)
		{

			if(kk1>=3)
				break;
			if((lastcommand[kk]>=0x30 && lastcommand[kk]<=0x39)||(lastcommand[kk]>='a'  && lastcommand[kk]<='f')||(lastcommand[kk]>='A'  && lastcommand[kk]<='F'))
			{
				str_numeral[kk1]=lastcommand[kk];
				str_numeral[kk1+1]=0;
				kk1++;
			}


			if(lastcommand[kk]=='r' || lastcommand[kk]=='R')
			{
				ConvertCharToHex(str_numeral,&reg_offset);
				content=sys_read_pci_config_word(Finded_PCIDeviceID[ii-1].PCIDeviceID, reg_offset); //read back base addr
				printf("\n DEV:%08X ,reg 0x%02x,value:0x%08x\n",Finded_PCIDeviceID[ii-1].PCIDeviceID,reg_offset,content);

				break;
			}
			else if(lastcommand[kk]=='w' || lastcommand[kk]=='W')
			{
				kk++;
				for(kk1=0;lastcommand[kk]!=0;kk++)
				{
					if(kk1>=8)
					break;
					if((lastcommand[kk]>=0x30 && lastcommand[kk]<=0x39)||(lastcommand[kk]>='a'  && lastcommand[kk]<='f')||(lastcommand[kk]>='A'  && lastcommand[kk]<='F'))
					{
						str_setvalue[kk1]=lastcommand[kk];
						str_setvalue[kk1+1]=0;
						kk1++;
					}
					else
					{
						printf("\n syntax error !!\n");
						break;
					}

				}
				ConvertCharToHex(str_numeral,&reg_offset);
				ConvertCharToHex(str_setvalue,&setvalue);

				if(reg_offset==4||reg_offset==6)
				sys_write_pci_config_halfword(Finded_PCIDeviceID[ii-1].PCIDeviceID,reg_offset,setvalue);
				else
				sys_write_pci_config_word(Finded_PCIDeviceID[ii-1].PCIDeviceID,reg_offset,setvalue);


				content=sys_read_pci_config_word(Finded_PCIDeviceID[ii-1].PCIDeviceID, reg_offset); //read back base addr
				printf("\n DEV:%08X ,reg 0x%02x,value:0x%08x\n",Finded_PCIDeviceID[ii-1].PCIDeviceID,reg_offset,content);
				break;
			}



		}


			}
		}
		else
		break;



		mem_ar = (mem_ar&0xfffffffe);//bit0:IO/MEM indicator
			while(1)
				{
				printf("\nInput Register offset (input 6. exit):");

				/*Convert HEX char to  decimal*/
				//scanf("%s",&soffset);

				input_value(soffset);


				ConvertCharToHex(soffset,&offset);
				if(offset==6)
				break;

				printf("\n Input 1.Read or 2.Write:");
				//scanf("%d",&RWselect);
				//input_value(&RWselect);
			    //while((RWselect = getc())== 0);

				PCI_WAIT_INPUT_CHAR(RWselect);
				RWselect -= 0x30;



				printf("\n Input  1.Byte or 2.Word or 3.DWord:");
				//scanf("%d",&BWDselect);
				PCI_WAIT_INPUT_CHAR(BWDselect);
				BWDselect -= 0x30;

				//BWDselect =1;
				MemBaseTest_8139_Byte(mem_ar,offset,RWselect,BWDselect);
#if 0
				for(aa=0;Finded_PCIDeviceID[aa].PCIDeviceID.Enable==1;aa++)
				{
					if(Finded_PCIDeviceID[aa].dev_ven==PCI_BRIDGE_DEVICE_VENDOR_ID)
					{
						status=sys_read_pci_config_halfword(Finded_PCIDeviceID[aa].PCIDeviceID,PCI_CSH_STATUS_REG);

						if((status & PCI_STATUS_PARITY_ERROR))
						printf("\nThe Bridge[0x%08x] is Parity error !!\n",Finded_PCIDeviceID[aa].dev_ven);
						if((status & PCI_STATUS_SERR_ERROR))
						printf("\nThe Bridge[0x%08x] of SERR# is Enable !!\n",Finded_PCIDeviceID[aa].dev_ven);
						if((status & PCI_STATUS_R_MASTER_ABORT))
						printf("\n The Bridge[0x%08x] is Received master abort as master !!\n",Finded_PCIDeviceID[aa].dev_ven);
						if((status & PCI_STATUS_R_TARGET_ABORT))
						printf("\n The Bridge[0x%08x] is Received Target abort as master !!\n",Finded_PCIDeviceID[aa].dev_ven);
						if((status & PCI_STATUS_S_TARGET_ABORT))
						printf("\n The Bridge[0x%08x] is Signaled Target abort as target !!\n",Finded_PCIDeviceID[aa].dev_ven);
						if((status & PCI_STATUS_MASTER_PARITY_ERROR))
						printf("\nThe Bridge[0x%08x] is  Master data parity error !!\n",Finded_PCIDeviceID[aa].dev_ven);

					}

				}


				status=sys_read_pci_config_halfword(Finded_PCIDeviceID[ii].PCIDeviceID,PCI_CSH_STATUS_REG);

				if((status & PCI_STATUS_PARITY_ERROR))
					printf("\n The target[0x%08x] is Parity error !!\n",Finded_PCIDeviceID[ii-1].dev_ven);
				if((status & PCI_STATUS_SERR_ERROR))
					printf("\n The target[0x%08x] of SERR# is Enable !!\n",Finded_PCIDeviceID[ii-1].dev_ven);
				if((status & PCI_STATUS_R_MASTER_ABORT))
					printf("\nThe target[0x%08x] is Received master abort as master !!\n",Finded_PCIDeviceID[ii-1].dev_ven);
				if((status & PCI_STATUS_R_TARGET_ABORT))
					printf("\nThe target[0x%08x] is Received Target abort as master !!\n",Finded_PCIDeviceID[ii-1].dev_ven);

				if((status & PCI_STATUS_S_TARGET_ABORT))
					printf("\nThe target[0x%08x] is Signaled Target abort as target !!\n",Finded_PCIDeviceID[ii-1].dev_ven);
				if((status & PCI_STATUS_MASTER_PARITY_ERROR))
					printf("\nThe target[0x%08x] is Master data parity error !!\n",Finded_PCIDeviceID[ii-1].dev_ven);

#endif
				}

			break;
                     /***************************************/
            default:
                printf("Exit Aridge Test ..\n");
                return;
        }

    }while (Item!=0);



}


U_BOOT_CMD(
 	pci,	1,	1,	rt2880_pci_scan,
 	"pci   - Display to all DMA status  !!\n",
 	"kaiker,sdd   - !!\n"
);


void set_scatter_len(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32 regValue;




	rt2880_hdrlen = simple_strtoul(argv[1], NULL, 10);

	if(rt2880_hdrlen == 999)
	{
		force_queue_n = 1;
		printf("\n Force tx DMA to Queue1 \n");
		return;
	}
	else if(rt2880_hdrlen == 888)
	{
		force_queue_n = 0;
		printf("\n Force tx DMA to Queue0 \n");
		return;
	}
	else if(rt2880_hdrlen == 777)
	{
		force_queue_n = 3;
		printf("\n Force tx DMA is Disable !! \n");
		return;
	}


   while(1)
	{
		regValue = INL(rt2880_pdev, RT2880_PDMA_GLO_CFG);
		if((regValue & RT2880_RX_DMA_BUSY))
		{
			printf("\n  RT2880_RX_DMA_BUSY !!! ");
			continue;
		}
		if((regValue & RT2880_TX_DMA_BUSY))
		{
			printf("\n  RT2880_TX_DMA_BUSY !!! ");
			continue;
		}
		break;
	}

	 regValue=INL(rt2880_pdev, RT2880_PDMA_GLO_CFG);
    udelay(100);
	regValue &= 0x000000FF;
	regValue |= (rt2880_hdrlen << 8);
    OUTL(rt2880_pdev, regValue, RT2880_PDMA_GLO_CFG);
	udelay(500);
	regValue=INL(rt2880_pdev, RT2880_PDMA_GLO_CFG);
	printf("\n Set Scatter Length = %d \n",rt2880_hdrlen);

	printf("\n RT2880_PDMA_GLO_CFG=%04X \n",regValue);

}



U_BOOT_CMD(
 	hdrlen,	2,	2,	set_scatter_len,
 	"rt2880_hdrlen   - Specify the header segment size in byte !!\n",
 	"rt2880_hdrlen [size]  - Specify the header segment size in byte !!\n"
);

void set_sdram_width(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	int val;
	u32 kk;

	val = simple_strtoul(argv[1], NULL, 10);

	if(val == 0)
	{
		printf("\n Set SDRAM Bus to 16 bit width\n");
		kk = *(volatile u_long *)(0xA0300304);
		kk &=  ~(1 << 24);
		*(volatile u_long *)(0xA0300304) = kk;
	}
	else if(val == 1)
	{
		printf("\n Set SDRAM Bus to 32 bit width\n");

		kk = *(volatile u_long *)(0xA0300304);
		kk |=  (1 << 24);
		*(volatile u_long *)(0xA0300304) = kk;
	}
}

U_BOOT_CMD(
 	sdram_width,	2,	2,	set_sdram_width,
 	"sdram_width   - Specify the SDRAM bus width !!\n",
 	"sdram_width [0/1]  - 0:16bit 1:32bit\n"
);


void set_cache_state(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32 kk;
	kk = simple_strtoul(argv[1], NULL, 10);

	mips_cache_set(kk);

	switch(kk)
	{
		case 0:
			printf("\n Set to CONF_CM_CACHABLE_NO_WA \n");
		break;
		case 1:
			printf("\n Set to CONF_CM_CACHABLE_WA \n");
		break;
		case 2:
			printf("\n Set to CONF_CM_UNCACHED \n");
		break;
		case 3:
			printf("\n Set to CONF_CM_CACHABLE_NONCOHERENT \n");
		break;
		case 4:
			printf("\n Set to CONF_CM_CACHABLE_CE \n");
		break;
	};

}

U_BOOT_CMD(
 	cache_set,	2,	2,	set_cache_state,
 	"cache_set   - Specify the header segment size in byte !!\n",
 	"cache_set [value]  - CONF_CM_CACHABLE_NO_WA 0 \n CONF_CM_CACHABLE_WA 1 \nCONF_CM_UNCACHED	2\nCONF_CM_CACHABLE_NONCOHERENT	3\nCONF_CM_CACHABLE_CE 4 \n"
);






void rt2880_sdpx_16n_plus_x(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{

	if (argc != 2) {
			printf ("Usage:\n%s\n", cmdtp->usage);
			return ;
	    }

	if(!memcmp(argv[0],"sdp.0",sizeof("sdp.0")))
	{

		sdp0_alig_16n_x = simple_strtoul(argv[1], NULL, 10);

		printf("\n Set SDP0 alignment to 16N+%d\n",sdp0_alig_16n_x);
	}
	else if(!memcmp(argv[0],"sdp.1",sizeof("sdp.1")))
	{
		sdp1_alig_16n_x = simple_strtoul(argv[1], NULL, 10);

		printf("\n Set SDP1 alignment to 16N+%d\n",sdp1_alig_16n_x);
	}
}


U_BOOT_CMD(
 	sdp,	2,	2,	rt2880_sdpx_16n_plus_x,
 	"sdp   - \n",
 	"sdp.0  x  x:[0,4,8,12]  - set SDP0 alignment to 16N+x  \n"
 	"sdp.1  x  x:[0,4,8,12]  - set SDP1 alignment to 16N+x  \n"
);

#if 0
void rt2880_internal_loopback_test(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	int rx_cnt,tx_cnt,length,i,valid_sent_cnt;

	printf("\n rt2880_internal_loopback_test \n");

	if (argc != 3) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return ;
	}
	NetTxPacket = NULL;

	if (!NetTxPacket) {
		int	i;
		/*
		 *	Setup packet buffers, aligned correctly.
		 */
		NetTxPacket = &PktBuf[0] + (PKTALIGN - 1);
		NetTxPacket -= (ulong)NetTxPacket % PKTALIGN;

		printf("\n NetTxPacket = 0x%08X \n",NetTxPacket);
		for (i = 0; i < PKTBUFSRX; i++) {
			NetRxPackets[i] = NetTxPacket + (i+1)*PKTSIZE_ALIGN;
		}
	}

	tx_cnt = simple_strtoul(argv[1], NULL, 10);

	length = simple_strtoul(argv[2], NULL, 10);

	//length = simple_strtoul(argv[3], NULL, 10);

	printf("\n Set tx count = %d \n",tx_cnt);
	printf("\n Set rx count = %d \n",rx_cnt);

	internal_loopback_test = RT2880_INTERNAL_LOOPBACK_ENABLE;

	rt2880_eth_setup(rt2880_pdev);



	 //print_packet(NetTxPacket,length);

	 valid_sent_cnt = 0;

	 for(i=0;i < tx_cnt ; i++)
	 {
	 	//printf("\n Tx Count[%d]\n",i);
		length = Gsw_Setup_Transmit_Packet(rt2880_pdev,length - 14,((0x30 + i) % 0x30));
	 	if(rt2880_eth_send(rt2880_pdev,NetTxPacket,length) == -1)
	 	{
	 		printf("\n Internal loopback, Send packet is fail !! \n");
			break;
	 	}
		else
		valid_sent_cnt++;

	 }



		if((i = rt2880_eth_recv(rt2880_pdev)) == 0 )
		{

			printf("\n Internal loopback, recv packet is fail !! \n");

		}
		printf("\n Internal loopback, Sent count =%d, recv  count = %d \n",valid_sent_cnt,i);

	rt2880_eth_halt(rt2880_pdev);
	//STOP_RT2880_ETH(rt2880_pdev);
	internal_loopback_test = RT2880_INTERNAL_LOOPBACK_DISABLE;



}
U_BOOT_CMD(
 	interloopback,	3,	2,	rt2880_internal_loopback_test,
 	"interloopback   - \n",
 	"interloopback  Ralink designed test !! \n"
 	"interloopback  [tx counter] [created packet length]\n"
);
#endif

#if 0
#define RALINK_SDRAM_CFG1 *(volatile u32 *)(0xA0300304)

void rt2880_auto_refresh_test(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32 len = 0x00100000;
	u32 refresh_period,tmp,t_start;
	int ii,kk = 2;
	volatile uchar *uncache_addr;


	if (argc != 3) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return ;
	}


	//uncache_addr = (uchar *)(((u32)&Pkt_Buf_Pool[0] & 0x0FFFFFFF) | 0xA0000000);
	uncache_addr = (uchar *)(((u32)0x8a100000 & 0x0FFFFFFF) | 0xA0000000);


	printf("\n Test Memory Size:%d ,Address:[0x%08X] \n",len,uncache_addr);

	refresh_period = simple_strtoul(argv[1], NULL, 16);
	refresh_period &= 0x0000FFFF;
	kk = simple_strtoul(argv[2], NULL, 10);

	printf("\n Set 0x%04X clock cycles with auto refresh testing !! \n",refresh_period);


	for(ii=0 ; ii < len ; ii++)
	uncache_addr[ii] = ii % 0xFF;


	tmp  = RALINK_SDRAM_CFG1;
	tmp &= 0xFFFF0000;
	tmp |= refresh_period;
	RALINK_SDRAM_CFG1 = tmp;

	tmp  = RALINK_SDRAM_CFG1;

	printf("\n Set 0x%08X to RALINK_SDRAM_CFG1 \n",tmp  );

	printf("\n Wait %d sec \n",kk);





	t_start = get_timer(0);

	while(get_timer(t_start)<= (kk * CFG_HZ));

	printf("\n Start testing !!\n");
	for(ii=0 ; ii < len ; ii++)
	{

		if(uncache_addr[ii] != ii % 0xFF)
		{
			printf("\n Fail !! addr[0x%08X],The fail's content:[%02X].The right's content:[%02X] \n",&uncache_addr[ii],uncache_addr[ii],ii % 0xFF);
		}

	}
	printf("\n Test finish  !!\n");


   printf("\n\n\n\n");



}

U_BOOT_CMD(
 	refresh,	3,	2,	rt2880_auto_refresh_test,
 	"refresh   - \n",
 	"refresh  Ralink designed test !! \n"
 	"refresh  [tx counter] [created packet length]\n"
);
#endif

#if 0
void rt2880_gmac_dma_test(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(!memcmp(argv[1],"scatter",sizeof("scatter")))
	{
		if(!memcmp(argv[2],"off",sizeof("off")))
		{
			printf("\n Header and payload scatter is disable !!\n");
			header_payload_scatter_en = DISABLE;
		}
		else
		{
			printf("\n Header and payload scatter is Enable !!\n");
			header_payload_scatter_en = ENABLE;
		}
	}
	else if(!memcmp(argv[1],"dup_tx_ring",sizeof("dup_tx_ring")))
	{
		if(!memcmp(argv[2],"off",sizeof("off")))
		{
			printf("\n Header and payload scatter is disable !!\n");
			header_payload_scatter_en = DISABLE;
		}
		else
		{
			printf("\n Header and payload scatter is Enable !!\n");
			header_payload_scatter_en = ENABLE;
		}
	}
	else if(!memcmp(argv[1],"buf_sram",sizeof("buf_sram")))
	{
		if(!memcmp(argv[2],"on",sizeof("on")))
		{
			rt2880_buf_in_esram_en = ENABLE;

			printf("\nPacket Buffer is re-allocate to SRAM !! \n");


			PktBuf = (uchar *)CFG_EMBEDED_SRAM_BUF_START;
			printf("\n Descriptor in SRAM \n Set Packet Buffer Point in [0x%08X]\n",PktBuf);




		}
		else if(!memcmp(argv[2],"off",sizeof("off")))
		{
			rt2880_buf_in_esram_en = DISABLE;
			PktBuf = Pkt_Buf_Pool;
			printf("\nPacket Buffer is re-allocate to DRAM !! \n");

		}
	}
	else if(!memcmp(argv[1],"desc_sram",sizeof("desc_sram")))
	{
		if(!memcmp(argv[2],"on",sizeof("on")))
		{
			rt2880_desc_in_esram = ENABLE;

			rx_ring = (struct PDMA_txdesc *)CFG_EMBEDED_SRAM_FOR_RXRING0_DESC;
			tx_ring0 = (struct PDMA_txdesc *)CFG_EMBEDED_SRAM_FOR_TXRING0_DESC;

			printf("\nRx Ring Descriptor is re-allocate to SRAM[0x%08X] \n",rx_ring);
			printf("\nTx Ring0 Descriptor is re-allocate to SRAM[0x%08X] \n",tx_ring0);


		}
		else if(!memcmp(argv[2],"off",sizeof("off")))
		{
			rt2880_desc_in_esram = DISABLE;

			rx_ring = KSEG1ADDR((ulong)&rx_ring_cache[0]);
			tx_ring0 = KSEG1ADDR((ulong)&tx_ring0_cache[0]);

			printf("\nRx Ring Descriptor is re-allocate to DRAM[0x%08X] \n",rx_ring);
			printf("\nTx Ring0 Descriptor is re-allocate to DRAM[0x%08X] \n",tx_ring0);

		}
	}
	else if(!memcmp(argv[1],"debug",sizeof("debug")))
	{
		if(!memcmp(argv[2],"on",sizeof("on")))
		{
			rt2880_debug_en = ENABLE;

			printf("\n Debug Enable\n");

		}
		else if(!memcmp(argv[2],"off",sizeof("off")))
		{
			rt2880_debug_en = DISABLE;

			printf("\n Debug DISABLE\n");

		}

	}


/*
*PKT_HEADER_Buf;// = (uchar *)CFG_EMBEDED_SRAM_SDP0_BUF_START;

*/



}
U_BOOT_CMD(
 	dmatest,	3,	2,	rt2880_gmac_dma_test,
 	"dmatest   - \n",
 	"dmatest  scatter on/off,Header and payload scatter enable/disable \n"
 	"dmatest  [tx counter] [created packet length]\n"
);
#endif

u32 mii_mgr_read(u32 phy_addr, u32 phy_register, u32 *read_data)
{
    u32 volatile  status;
    u32 volatile  ii,t_start;
    t_start = get_timer(0);
    // clear previous rw_ok status
    while(1)
    {
		 if(!(RT2880_MDIO_ACCESS_R & (0x1 << 31)))
		 {
			break;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read/Write operation is ongoing !!\n");
			return 0;
		 }
    }
    RT2880_MDIO_ACCESS_R = 0;
    ii = 0;
    ii = (phy_addr << 24) | (phy_register << 16);
    //printf("\n Set Command [0x%08X] to PHY !!\n",ii);
    RT2880_MDIO_ACCESS_R = ii;
    ii |= (1 << 31);
    RT2880_MDIO_ACCESS_R = ii;
    t_start = get_timer(0);
    // clear previous rw_ok status
    while(1)
    {
    	 ii= RT2880_MDIO_ACCESS_R;
#ifdef DEBUG
		 printf("\n RT2880_MDIO_ACCESS_R = 0x%08X",ii);
#endif
		 if(!( ii & (0x1 << 31)))
		 {
		 	status = RT2880_MDIO_ACCESS_R;
			*read_data = (u32)(status & 0x0000FFFF);
			return 1;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read operation is ongoing and Time Out!!\n");
			return 0;
		 }
    }
}

u32 mii_mgr_write(u32 phy_addr, u32 phy_register, u32 write_data)
{
    u32 volatile  status;
    u32 volatile  ii,t_start;



	t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {

		 if(!(RT2880_MDIO_ACCESS_R & (0x1 << 31)))
		 {

			break;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read/Write operation is ongoing !!\n");
			return 0;
		 }
    }


    RT2880_MDIO_ACCESS_R = 0;
	ii = 0;
    ii = (phy_addr << 24) | (phy_register << 16) | (1 << 30) | write_data;
#ifdef DEBUG
	printf("\n Set Command [0x%08X] to PHY !!\n",ii);
#endif
    RT2880_MDIO_ACCESS_R = ii;

    ii |= (1 << 31);

	RT2880_MDIO_ACCESS_R = ii;




    t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {
    	 ii= RT2880_MDIO_ACCESS_R;
		 if(!( ii & (0x1 << 31)))
		 {
			return 1;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read operation is ongoing and Time Out!!\n");
			return 0;
		 }
    }
}

#ifndef BOB_USE
void rt2880_mdio_access(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	u32 addr;
	u32 phy_addr;
	u32 value = 0,bit_offset,temp;

	if(!memcmp(argv[0],"mdio.anoff",sizeof("mdio.anoff")))
	{
		value = RT2880_MDIO_CFG_R;
		value |= RT2880_BIT(15);
		RT2880_MDIO_CFG_R = value;
		puts("\n GMAC1 Force link status enable !! \n");
	}
	else if(!memcmp(argv[0],"mdio.anon",sizeof("mdio.anon")))
	{
		value = RT2880_MDIO_CFG_R;

		value &= ~(1 << 15);
		RT2880_MDIO_CFG_R = value;
		puts("\n GMAC1 Force link status disable !! \n");
	}
	else if(!memcmp(argv[0],"mdio.r",sizeof("mdio.r")))
	{
		if (argc != 3) {
			printf ("Usage:\n%s\n", cmdtp->usage);
			return ;
	    	}
		phy_addr = simple_strtoul(argv[1], NULL, 10);
		addr = simple_strtoul(argv[2], NULL, 10);
		phy_addr &=0x1f;


		if(mii_mgr_read(phy_addr, addr, &value))
		printf("\n mdio.r addr[0x%08X]=0x%04X\n",addr,value);
		else
		{
			printf("\n Read addr[0x%08X] is Fail!!\n",addr);
		}

		return;

	}
	else if(!memcmp(argv[0],"mdio.w",sizeof("mdio.w")))
	{

		if (argc != 4) {
			printf ("Usage:\n%s\n", cmdtp->usage);
			return ;
	    	}
		phy_addr = simple_strtoul(argv[1], NULL, 10);
		addr = simple_strtoul(argv[2], NULL, 10);
		value = simple_strtoul(argv[3], NULL, 16);
		phy_addr &=0x1f;

		if(mii_mgr_write(phy_addr, addr,value))
		{
   	    	printf("\n mdio.w addr[0x%08X]  value[0x%08X]\n",addr,value);
		}
		else
		{
			printf("\n Write[0x%08X] is Fail!!\n",addr);
		}

	}
	else if(!memcmp(argv[0],"mdio.wb",sizeof("mdio.wb")))
	{

		if (argc != 4) {
			printf ("Usage:\n%s\n", cmdtp->usage);
			return ;
	    }
		addr = simple_strtoul(argv[1], NULL, 10);

		bit_offset = simple_strtoul(argv[2], NULL, 10);

		value = simple_strtoul(argv[3], NULL, 10);

		if(Gsw_Read_PHY(addr,&temp))
		{

		}
		else
		{
			printf("\n Rasd PHY fail while mdio.wb was called\n");
			return;
		}

		if(value)
		{
			printf("\n Set bit[%d] to '1' \n",bit_offset);
			temp |= RT2880_BIT(bit_offset);
		}
		else
		{
			printf("\n Set bit[%d] to '0' \n",bit_offset);
			temp &= ~(RT2880_BIT(bit_offset));
		}


		if(Gsw_Write_PHY(addr,temp))
		{
   	    	printf("\n mdio.wb addr[0x%08X]  value[0x%08X]\n",addr,temp);
		}
		else
		{
			printf("\n Write[0x%08X] is Fail!!\n",addr);
		}

	}


     return ;
}
#endif

#ifndef BOB_USE
u32 Gsw_Read_PHY(u32 phy_register, u32 *read_data)
{
    u32 volatile  status;
    u32 volatile  ii,t_start;



	t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {

		 if(!(RT2880_MDIO_ACCESS_R & (0x1 << 31)))
		 {

			break;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read/Write operation is ongoing !!\n");
			return 0;
		 }
    }


    RT2880_MDIO_ACCESS_R = 0;
	ii = 0;
    ii = (0x1F << 24) | (phy_register << 16);

	//printf("\n Set Command [0x%08X] to PHY !!\n",ii);
    RT2880_MDIO_ACCESS_R = ii;

    ii |= (1 << 31);

	RT2880_MDIO_ACCESS_R = ii;




    t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {
    	 ii= RT2880_MDIO_ACCESS_R;
		 //printf("\n RT2880_MDIO_ACCESS_R = 0x%08X",ii);
		 if(!( ii & (0x1 << 31)))
		 {
		 	status = RT2880_MDIO_ACCESS_R;
			*read_data = (u32)(status & 0x0000FFFF);
			return 1;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read operation is ongoing and Time Out!!\n");
			return 0;
		 }
    }


}
u32 Gsw_Write_PHY(u32 phy_register, u32 write_data)
{
    u32 volatile  status;
    u32 volatile  ii,t_start;



	t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {

		 if(!(RT2880_MDIO_ACCESS_R & (0x1 << 31)))
		 {

			break;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read/Write operation is ongoing !!\n");
			return 0;
		 }
    }


    RT2880_MDIO_ACCESS_R = 0;
	ii = 0;
    ii = (0x1F << 24) | (phy_register << 16) | (1 << 30) | write_data;

	//printf("\n Set Command [0x%08X] to PHY !!\n",ii);
    RT2880_MDIO_ACCESS_R = ii;

    ii |= (1 << 31);

	RT2880_MDIO_ACCESS_R = ii;




    t_start = get_timer(0);

    // clear previous rw_ok status
    while(1)
    {
    	 ii= RT2880_MDIO_ACCESS_R;

		 if(!( ii & (0x1 << 31)))
		 {

			return 1;
		 }
		 else if(get_timer(t_start) > (5 * CFG_HZ))
		 {
		 	printf("\n MDIO Read operation is ongoing and Time Out!!\n");
			return 0;
		 }
    }


}

U_BOOT_CMD(
 	mdio,	4,	1,	rt2880_mdio_access,
 	"mdio   - Ralink PHY register R/W command !!\n",
 	"mdio.r [phy register(dec)] - PHY read \n"
 	"mdio.w [phy register(dec)] [data(HEX)] - PHY write \n"
 	"mdio.anoff GMAC1 Force link status enable !!  \n"
 	"mdio.anon GMAC1 Force link status disable !!  \n"
 	"mdio.wb [phy register(dec)] [bit offset(Dec)] [Value(0/1)]  \n"
);





/******************************************************************************
 *
 * FUNCTION:  Gsw_Setup_Transmit_Packet
 * PURPOSE:
 *
 ******************************************************************************/
int Gsw_Setup_Transmit_Packet(struct eth_device* dev,int len,u8 patten)
{
    u32    ii;
    u8     *ptr;


    ptr = NetTxPacket;

    // setup da
    memcpy(ptr, dev->enetaddr, 6);

    ptr += 6;

    // setup sa
    memcpy(ptr, dev->enetaddr, 6);

    ptr[5] = 0x99;

    ptr += 6;

    // setup type
    *ptr++ = 0x08;

    *ptr++ = 0x00;

    // setup payload
    for (ii = 0; ii < len; ii++)
    {
        *ptr++ = patten;//(ii + 1);
    }
	return ((int)(ptr - NetTxPacket));
}



#endif
//==========================================================
// PCI test
//==========================================================

// PCI Bus MAX define

#define	PCIB_MAX_DEVICE_TYPE_NUM      0x13
#define PCIB_MAX_BAR_NUM	      0x02
#define	PCIB_MAX_BUS_NUM	      0x01 //bit[23-16],
#define	PCIB_MAX_DEVICE_NUM	      0x13 //bit[15-11]
#define	PCIB_MAX_FUNCTION_NUM	      0x04 //bit[10-8]
#define	PCIB_MAX_REG_NUM	      0x3c //bit[7-2]


// PCIB Config define
#define PCIB_CONFIG_EN                0x80000000
#define PCIB_BUS_NUM_BASE             0x10000
#define PCIB_DEV_NUM_BASE             0x800
#define PCIB_FUN_NUM_BASE             0x100
#define PCIB_REG_NUM_BASE             0x4


u32 sys_read_pci_config_word(PCIDeviceIDStruct PCIDeviceID, u32 Reg) //for Bridge only
{
    u32 uwData,ii;

    PCIDeviceID.Enable = 1;
#if 0
    PCIDeviceID.RegNum = Reg;
    PCI_BRIDGE_CONFIG_ADDR= *(u32*)&PCIDeviceID;
#else
    PCIDeviceID.RegNum = Reg>>2;
    PCI_BRIDGE_CONFIG_ADDR= PCIB_CONFIG_EN +PCIDeviceID.BusNum*PCIB_BUS_NUM_BASE
                            +PCIDeviceID.DevNum*PCIB_DEV_NUM_BASE+PCIDeviceID.FunNum*PCIB_FUN_NUM_BASE
                            +PCIDeviceID.RegNum*PCIB_REG_NUM_BASE;

#endif
    for (ii=0;ii<1000;ii++);
    uwData =  PCI_BRIDGE_CONFIG_DATA;

    return uwData;
}

u16 sys_read_pci_config_halfword(PCIDeviceIDStruct PCIDeviceID, u32 Reg)//for Bridge only
{
    u32 lw;

    lw = sys_read_pci_config_word(PCIDeviceID, (Reg&0xfc));
    switch(Reg % 4)
    {
        case 0:
	case 1:
	    lw &= 0x0000FFFF;
	    break;
	case 2:
	case 3:
	    lw &= 0xFFFF0000;
	    lw = lw >> 16;
	    break;
    }

    return (u16)lw;
}

u8 sys_read_pci_config_byte(PCIDeviceIDStruct PCIDeviceID, u32 Reg)//for Bridge only
{
    u32 lw;

    lw = sys_read_pci_config_word(PCIDeviceID, (Reg&0xfc));
    switch(Reg % 4)
    {
        case 0:
	    lw &= 0x000000FF;
	    break;
	case 1:
	    lw &= 0x0000FF00;
   	    lw = lw >> 8;
	    break;
	case 2:
            lw &= 0x00FF0000;
            lw = lw >> 16;
            break;
 	case 3:
            lw &= 0xFF000000;
            lw = lw >> 24;
 	break;
    }

    return (u8)lw;
}



void sys_write_pci_config_word(PCIDeviceIDStruct PCIDeviceID, u32 Reg, u32 data)//for Bridge only
{
    u32 ii;
    PCIDeviceID.Enable = 1;
#if 0
    PCIDeviceID.RegNum = (Reg&0xfc);
    PCI_BRIDGE_CONFIG_ADDR= *(u32 *)&PCIDeviceID;
#else
    PCIDeviceID.RegNum = (Reg&0xfc)>>2;
    PCI_BRIDGE_CONFIG_ADDR= PCIB_CONFIG_EN +PCIDeviceID.BusNum*PCIB_BUS_NUM_BASE
                             +PCIDeviceID.DevNum*PCIB_DEV_NUM_BASE+PCIDeviceID.FunNum*PCIB_FUN_NUM_BASE
		             +PCIDeviceID.RegNum*PCIB_REG_NUM_BASE;

#endif
    for (ii=0;ii<1000;ii++);
    PCI_BRIDGE_CONFIG_DATA   = data;
}

void sys_write_pci_config_halfword(PCIDeviceIDStruct PCIDeviceID, u32 Reg, u16 data)//for Bridge only
{
    u32 lw;

    lw = sys_read_pci_config_word(PCIDeviceID, (Reg&0xfc));
    switch(Reg % 4)
    {
        case 0:
	case 1:
	    lw &= 0xFFFF0000;
            lw += data;
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
	    break;
	case 2:
	case 3:
            lw &= 0x0000FFFF;
            lw += (u32)(((u32)data) << 16);
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
            break;
    }

}

void sys_write_pci_config_byte(PCIDeviceIDStruct PCIDeviceID, u32 Reg, u8 data)//for Bridge only
{
    u32 lw;

    lw = sys_read_pci_config_word(PCIDeviceID, (Reg&0xfc));
    switch (Reg % 4)
    {
        case 0:
	    lw &= 0xFFFFFF00;
	    lw += data;
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
	    break;
	case 1:
            lw &= 0xFFFF00FF;
	    lw += (u32)(((u32)data) << 8);
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
	    break;
	case 2:
            lw &= 0xFF00FFFF;
	    lw += (u32)(((u32)data) << 16);
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
	    break;
	case 3:
   	    lw &= 0x00FFFFFF;
	    lw += (u32)(((u32)data) << 24);
	    sys_write_pci_config_word(PCIDeviceID, (Reg&0xfc), lw);
	    break;
    }

}



void kaiker_AssignPCIResource(PCIDeviceIDStruct PCIDeviceID , u32 *PciMemStart, u32 *PciIoStart)
{
    u32  lw,ii,jj, Reg, BaseAddrReg, BaseSize;
    u32  dwAlignmentSize;
    u32  device_id;

    device_id = sys_read_pci_config_word(PCIDeviceID, 0x00);         // read Device ID


    for (ii = 0 ; ii < PCIB_MAX_BAR_NUM ; ii++) //BAR_NUM:0x06
    {
        Reg = PCI_CSH_BASE_ADDR_REG + (ii * 4); //0x10+4xi

		sys_write_pci_config_word(PCIDeviceID, Reg, 0xFFFFFFFF); //write 0xffffffff,then
		lw = sys_read_pci_config_word(PCIDeviceID, Reg);         // read back value
        printf("\n\n******BAR%d= 0x%08x ***********\n",ii,lw);
		if ((lw == 0) || ((lw & 0xffffffff) == 0xffffffff))
		{
			printf("Base Address Register %d is not exist !!\n",ii);
			continue;
		}
		else		/* else-if */
		{
			if ((lw & 0x01) != 0x00)	/* it's IO base */
			{
				if(device_id == PCI_BRIDGE_DEVICE_VENDOR_ID) /*If current device is PCI bridge*/
				{
					//Open all mem space
				#if 1
				RALINK_PCI_BAR0SETUP_ADDR = 0xFFFF0001;//Open 2G mem space
				RALINK_PCI_BAR1SETUP_ADDR = 0xFFFF0001;//Open 2G mem space
				#endif
				RALINK_PCI_IMBASEBAR0_ADDR = 0;
				RALINK_PCI_IMBASEBAR1_ADDR = 0;
					sys_write_pci_config_word(PCIDeviceID, Reg, SYS_DDR_SDRAM_BASE_ADDR);
					printf("\nSet  IO  base of the PCI bridge\n");

					printf("\n\n******write = 0x%08x *read = 0x%08x**********\n",SYS_DDR_SDRAM_BASE_ADDR,sys_read_pci_config_word(PCIDeviceID, Reg));
				}
				else
				{
    	    		lw >>= 2; // 31..2:base addr.
    	    		for(jj=2; jj < 32; jj++)
					{
						if (lw & 0x01 == 0x01) //[b31..b2],only 1 bit will be "1"
						{
							break;  //valid bit found,
						}
						lw >>= 1;
					}
					BaseSize = 1 << jj;// size is power of 2
					if (BaseSize >= PCI_IO_SPACE_ALIGNMENT) //why:0x4,???
					{
						dwAlignmentSize = BaseSize;
					}
					else
					{
						dwAlignmentSize = PCI_IO_SPACE_ALIGNMENT;//4
					}
					printf("This is IO Base Space Register !\n The request of size is %d bytes\n",dwAlignmentSize);
					if ((*PciIoStart % dwAlignmentSize) != 0)
					{
						*PciIoStart = ((*PciIoStart / dwAlignmentSize) + 1) * dwAlignmentSize;
					}
			BaseAddrReg = *PciIoStart;
			*PciIoStart += BaseSize; // CurrentIOStart + Current_BaseSz => NextIOStart
			printf("set I/O base:0x%8x\n",BaseAddrReg);
			sys_write_pci_config_word(PCIDeviceID, Reg, BaseAddrReg);
			printf("\n\n******write = 0x%08x *read = 0x%08x**********\n",BaseAddrReg,sys_read_pci_config_word(PCIDeviceID, Reg));
	    	}
	    }//IO base
	    else if((lw & 0x01) != 0x01)		/* it's Memory base */
	    {
		if(device_id == PCI_BRIDGE_DEVICE_VENDOR_ID)/*If current device is PCI bridge*/
	    	{
	    		printf("\nSet Memory base of the PCI bridge\n");
	    		sys_write_pci_config_word(PCIDeviceID, Reg, SYS_DDR_SDRAM_BASE_ADDR);
	    		printf("\n\n******write = 0x%08x *read = 0x%08x**********\n",SYS_DDR_SDRAM_BASE_ADDR,sys_read_pci_config_word(PCIDeviceID, Reg));
	    	}
		else
		{
		        lw >>= 4;
			for (jj=4; jj < 32; jj++)
			{
			    if (lw & 0x01 == 0x01)
			    {
			        break;
			    }
			    lw >>= 1;
			}
			BaseSize = 1 << jj;
			if (BaseSize>=PCI_MEM_SPACE_ALIGNMENT) //16
			{
			    dwAlignmentSize=BaseSize;
			}
			else
			{
			    dwAlignmentSize=PCI_MEM_SPACE_ALIGNMENT;
			}
			printf("This is MEMORY Base Space Register !\n  The request of size is %d bytes\n",dwAlignmentSize);
			if ((*PciMemStart % dwAlignmentSize) != 0)
			{
			    *PciMemStart = ((*PciMemStart / dwAlignmentSize) + 1) * dwAlignmentSize;
			}
			BaseAddrReg = *PciMemStart;
			*PciMemStart += BaseSize;
			printf("set  MEM base :0x%8x\n",BaseAddrReg);
			sys_write_pci_config_word(PCIDeviceID, Reg, BaseAddrReg);
			printf("\n\n******write = 0x%08x *read = 0x%08x**********\n",BaseAddrReg,sys_read_pci_config_word(PCIDeviceID, Reg));
		}
	    }
        }
    }
}



void Init_LatTimer_CacheSize(PCIDeviceIDStruct PCIDeviceID,u32 isMaster)
{

    u32  CMDType;


    PCIDeviceID.RegNum = PCI_CSH_CACHE_LINE_SIZE_REG;
    CMDType = sys_read_pci_config_word(PCIDeviceID, PCI_CSH_CACHE_LINE_SIZE_REG);

    printf("   Init_LatTimer_CacheSize   is called \n\n");
    printf("    CACHE_LINE_SIZE_REG default value 0x%08x\n",CMDType);

   CMDType=CMDType & 0xFFFF0000;
 //  if(isMaster)
  // {
   	 CMDType=CMDType | 0x00000014;//Cache size
   	 CMDType=CMDType | 0x00001000;//Latency Timer
  // }
  // else
    //     CMDType=CMDType | 0x00001000;//Latency Timer

    sys_write_pci_config_word(PCIDeviceID, PCI_CSH_CACHE_LINE_SIZE_REG, CMDType);

    CMDType = sys_read_pci_config_word(PCIDeviceID, PCI_CSH_CACHE_LINE_SIZE_REG);
    printf("    CACHE_LINE_SIZE_REG Set value 0x%08x\n",CMDType);
}
//====================================================================
// * Function Name: flib_EnablePCIDevice                                 (0708 => ok)
// * Description: 1.Read Command register byte
//                2.Enable BOTH IO/MEM space response
// * Input: PCIDeviceID
//====================================================================
void flib_EnablePCIDevice(PCIDeviceIDStruct PCIDeviceID)
{
    u16 CMDType;
    PCIDeviceID.RegNum = PCI_CSH_COMMAND_REG;
    CMDType = sys_read_pci_config_halfword(PCIDeviceID, PCI_CSH_COMMAND_REG);

    printf("   flib_EnablePCIDevice   is called \n\n");
    printf("    COMMAND_REG default value 0x%04x\n",CMDType);

    printf("    Enable PCI DEV's IO & MEM space response\n");

    sys_write_pci_config_halfword(PCIDeviceID, PCI_CSH_COMMAND_REG, CMDType | PCI_CMD_IO_ENABLE |
    	PCI_CMD_MEM_ENABLE|PCI_CMD_MEM_WRITE_INVALIDATE|PCI_CMD_FBB_ENABLE|PCI_CMD_SERR_ENABLE|
    	PCI_CMD_STEPPING_CONTROL|PCI_CMD_PARITY_ERR);

    CMDType = sys_read_pci_config_halfword(PCIDeviceID, PCI_CSH_COMMAND_REG);
    printf("    COMMAND_REG Set value 0x%04x\n",CMDType);
}


//====================================================================
// * Function Name: flib_SetPCIMaster                                     (0708 => ok)
// * Description: 1.Read Command register byte
//                2.Write Back (PCI_CMD_BUS_MASTER_ENABLE)
// * Input: PCIDeviceID
//====================================================================
void flib_SetPCIMaster(PCIDeviceIDStruct PCIDeviceID)
{
    u32 CMDType;
    PCIDeviceID.RegNum = PCI_CSH_COMMAND_REG;
   //  printf("   flib_SetPCIMaster   is called \n\n");
 //`   printf("    COMMAND_REG default value 0x%2x\n",CMDType);

    CMDType = sys_read_pci_config_byte(PCIDeviceID, PCI_CSH_COMMAND_REG);
    printf("    PCI BUS master mode enable..\n");
    sys_write_pci_config_byte(PCIDeviceID, PCI_CSH_COMMAND_REG, CMDType | PCI_CMD_BUS_MASTER_ENABLE);
}


#if 0
void kaiker_PCI_Bridge_Test(void)
{
    u32 uwFAIL_CNT=0,uwReadWord,uwResult,jj,Reg;
    u32 M_bass_address=PCI_ALLOCATE_SPACE,IO_bass_address=PCI_ALLOCATE_SPACE;
     //PCIDeviceIDStruct PCIDeviceID;
/*
 *  Using Random Value to test PCI bridge interl regsiter
 */
    printf("=>Test Internal registers...\n");




	for(jj=0;Finded_PCIDeviceID[jj].PCIDeviceID.Enable==1;jj++)
	{
		printf("-  Get IO/MEMORY size and allocate space to the  Dev%d \n",Finded_PCIDeviceID[jj].PCIDeviceID.DevNum);

		kaiker_AssignPCIResource(Finded_PCIDeviceID[jj].PCIDeviceID,&M_bass_address,&IO_bass_address);
	}


 //Enable the all device and set them to master.
  //Add by kaiker

  for(jj=0;Finded_PCIDeviceID[jj].PCIDeviceID.Enable==1;jj++)
  {
   	    printf("EnablePCIDevice,ID=0x%08x\n",Finded_PCIDeviceID[jj].dev_ven);
            flib_EnablePCIDevice(Finded_PCIDeviceID[jj].PCIDeviceID);
		//	printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));
			//*(volatile u_long *)(0xA0301004) = 0xFFFFFFFF;
            printf("SetPCIMaster!\n");
            flib_SetPCIMaster(Finded_PCIDeviceID[jj].PCIDeviceID);
			//printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));
			//*(volatile u_long *)(0xA0301004) = 0xFFFFFFFF;
             printf("Init_LatTimer_CacheSize!\n");
             if(Finded_PCIDeviceID[jj].dev_ven != PCI_BRIDGE_DEVICE_VENDOR_ID)
             {
             	Init_LatTimer_CacheSize(Finded_PCIDeviceID[jj].PCIDeviceID,0);
             }
             else
             {
             	Init_LatTimer_CacheSize(Finded_PCIDeviceID[jj].PCIDeviceID,1);


             }
         	//printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));
   			//*(volatile u_long *)(0xA0301004) = 0xFFFFFFFF;
  }//mask by kaiker

//Add by kaiker
}
#endif

#if 1
void kaiker_PCI_Scan_Bus_Test(void)
{
    u32 ii,jj,kk,ll,mm;
    u32 ID,TempValue;
    int         devnum=0,find_device=0;

	PCI_BRIDGE_CLOCK = 0x4;

	//printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));

	*(volatile u_long *)(0xA0500004) = 0xFFFFFFFF;
	//le32_to_cpu(*(volatile u_long *)(0xA0301080)) = 0;

	udelay(5000);
    //PCI Device Scan (BUS/DEVICE/FUNCTION)
    printf("---------------Bus/Device/Function Scan --------------------------\n");
    for (ii=0;ii < PCIB_MAX_BUS_NUM; ii++)
    {//bus
        printf("  --Bus %d Scan... \n",ii);
	for (jj=0;jj < PCIB_MAX_DEVICE_NUM; jj++)
	{//dev
	    //Read the ID to check the exist of the device(Function-0)
    	    PCI_BRIDGE_CONFIG_ADDR = PCIB_CONFIG_EN + (ii*PCIB_BUS_NUM_BASE)+(jj*PCIB_DEV_NUM_BASE);
			udelay(500);
            printf("  --PCI_BRIDGE_CONFIG_ADDR 0x%x \n",PCI_BRIDGE_CONFIG_ADDR);
            ID = PCI_BRIDGE_CONFIG_DATA;
	    if((ID != 0x00000000) && (ID != 0xFFFFFFFF)) //f0
	    {//DEV found
	    	find_device=1;
	        printf("       --Device %d Found... Bus %d / Dev %d /Fun 0 => ID:0x%08x \n",jj,ii,jj,ID);
            // Dump the Config Space of the found DEV's Function-0
                printf("        DEVICE(0x%08x)'s  Configuration :\n",ID);

                Finded_PCIDeviceID[devnum].PCIDeviceID.BusNum = ii;
                Finded_PCIDeviceID[devnum].PCIDeviceID.DevNum = jj;
                Finded_PCIDeviceID[devnum].PCIDeviceID.FunNum = 0x00;
                Finded_PCIDeviceID[devnum].PCIDeviceID.Enable=1;
                Finded_PCIDeviceID[devnum].dev_ven=ID;

	//	kaiker_PCI_Bridge_Test();

#if 1
#if 0
	        for (ll=0;ll<4 /*24*/;ll++)
	        {
                    //for (mm=0;mm<0x10000;mm++);
                    printf("            Value read at 0x%02x is 0x%08x\n",(ll*4),sys_read_pci_config_word(Finded_PCIDeviceID[devnum].PCIDeviceID,(ll*4)));
	        }
#endif

    		for (ll=0;ll<24;ll++)
		{
		    PCI_BRIDGE_CONFIG_ADDR= PCIB_CONFIG_EN +
		                             Finded_PCIDeviceID[devnum].PCIDeviceID.BusNum*PCIB_BUS_NUM_BASE+
		                             Finded_PCIDeviceID[devnum].PCIDeviceID.DevNum*PCIB_DEV_NUM_BASE+
		                             Finded_PCIDeviceID[devnum].PCIDeviceID.FunNum*PCIB_FUN_NUM_BASE+
		                             ll*4;
                    printf("            Value read at 0x%02x is 0x%8x\n",(ll*4),PCI_BRIDGE_CONFIG_DATA);
                }

#endif

		devnum++;

	    }//DEV found
#if 1
	    else //f0
	    {
	        printf("       --Device %d Not Found... \n",jj);
	    }
#endif
	}//dev
    }//bus
    printf("  --PCIB Bus Scan Finish... \n");

	//printf("\n PCIRAW = 0x%08X \n",*(volatile u_long *)(0xA0301004));
	//*(volatile u_long *)(0xA0301004) = 0xFFFFFFFF;

	/*clear remnant of devices structl */
	for(;devnum<PCI_MAX_SLOT_NUM;devnum++)
	Finded_PCIDeviceID[devnum].PCIDeviceID.Enable=0;
#if 0
	if(find_device)
	{
		kaiker_PCI_Bridge_Test();
	}
	else
	{
		printf	("\n\n*****DEVICE NOT FIND******\n\n");
	}
#endif


}
#endif

#ifdef EV_BOARD
static void rt2880_mdio_set(u32 addr,u32 bit_offset,u32 value )
{
	u32 temp;


	if(Gsw_Read_PHY(addr,&temp))
	{

	}
	else
	{
		printf("\n Rasd PHY fail while mdio.wb was called\n");
		return;
	}

	if(value)
	{
		printf("\n Set bit[%d] to '1' \n",bit_offset);
		temp |= RT2880_BIT(bit_offset);
	}
	else
	{
		printf("\n Set bit[%d] to '0' \n",bit_offset);
		temp &= ~(RT2880_BIT(bit_offset));
	}


	if(Gsw_Write_PHY(addr,temp))
	{
		printf("\n mdio.wb addr[0x%08X]  value[0x%08X]\n",addr,temp);
	}
	else
	{
		printf("\n Write[0x%08X] is Fail!!\n",addr);
	}

}


#endif


static inline void mips_cache_set(u32 v)
{
	asm volatile ("mtc0 %0, $16" : : "r" (v));
}

#endif	/* CFG_CMD_NET && CONFIG_NET_MULTI && CONFIG_TULIP */
