/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************
 *
 * $Id: gpio.c,v 1.5 2007-06-28 13:39:47 winfred Exp $
 */
#include <config.h>
#include <common.h>

int gpio_set_dir_bit(u32 idx, u32 dir)
{
	u32 tmp = 0;

	if (0L <= idx && idx < RT2880GPIO_DATA_LEN) {
		tmp = RT2882_REG(RT2880_PIODIR_REG);
		if (dir & 1L) {
			tmp |= (1L << idx);
		}
		else {
			tmp &= ~(1L << idx);
		}
      RT2882_REG(RT2880_PIODIR_REG) = tmp;
	 } 
	  return 0;
}

int gpio_read_bit(u32 idx, u32 *value)
{
	u32 tmp = 0;

	tmp = RT2882_REG(RT2880_PIODATA_REG);

	if (0L <= idx && idx < RT2880GPIO_DATA_LEN) {
		tmp = (tmp >> idx) & 1L;
		*value = tmp;
		return 0;
	}
	return -1;
}

void gpio_write_bit(u32 idx, u32 value)
{
	u32 tmp = 0;
	if (0L <= idx && idx < RT2880GPIO_DATA_LEN) {
		tmp =RT2882_REG(RT2880_PIODATA_REG);
		if (value & 1L)
			tmp |= (1L << idx);
		else
			tmp &= ~(1L << idx);
		RT2882_REG(RT2880_PIODATA_REG)= tmp;
		}
	return;
}


