/*
 * (C) Copyright 2003
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * This file contains the configuration parameters for the RT2880 board.
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * Run U-Boot in SDRAM for debugging
 * a. modify TEXT_BASE in /board/rt2880/config.mk
 * b. define CFG_RUN_CODE_IN_RAM
 */
 //kaiker ,for RUN from Flash

#if (TEXT_BASE == 0x8B000000)
//#define CFG_RUN_CODE_IN_RAM

#endif

//#define DEBUG				1
//#define ET_DEBUG

#define CONFIG_RT2880_ETH		1	/* Enable built-in 10/100 Ethernet */

#define CONFIG_MIPS32		1	/* MIPS 4Kc CPU core	*/
//CONFIG_INCA_IP
#define FPGA_BOARD_CLOCK_RATE 25000000
#define PALMCHIP_CLOCK_DIVISOR 16
#define FPGA_BOARD_CLOCK_DIVISOR 32

/* allowed values: 100000000, 133000000, and 150000000 */

#ifdef EV_BOARD
#define CPU_CLOCK_RATE	266000000 /* default: 150 MHz clock for the MIPS core */
#else
#define CPU_CLOCK_RATE	FPGA_BOARD_CLOCK_RATE /* default: 150 MHz clock for the MIPS core */
#endif

#define SYSTEM_CLOCK_RATE CPU_CLOCK_RATE/2	/* default: 150 MHz clock for the MIPS core */

#define SERIAL_CLOCK_DIVISOR 16

#define CONFIG_BOOTDELAY	1	/* autoboot after 5 seconds	*/
#define CONFIG_ZERO_BOOTDELAY_CHECK /* stop autoboot procedure even the "bootdelay" has been set to 0 */

#define CONFIG_BAUDRATE		57600

#define CONFIG_SERVERIP 192.168.1.250
#define CONFIG_IPADDR   192.168.1.10
#define CONFIG_ETHADDR "00:AA:BB:CC:DD:11"
/* valid baudrates */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define	CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_PREBOOT	"echo;"	\
	"echo"

#undef	CONFIG_BOOTARGS

#if 0
#define	CONFIG_EXTRA_ENV_SETTINGS					\
	"ramargs=setenv bootargs root=/dev/ram rw\0"			\
	"addip=setenv bootargs $(bootargs) "				\
		"ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask)"	\
		":$(hostname):$(netdev):off\0"				\
	"addmisc=setenv bootargs $(bootargs) "				\
		"console=ttyS0,$(baudrate) "				\
		"ethaddr=$(ethaddr) "					\
		"panic=1\0"						\
	"flash_self=run ramargs addip addmisc;"				\
		"bootm $(kernel_addr) $(ramdisk_addr)\0"		\
	"kernel_addr=BFC40000\0"					\
	"u-boot=u-boot.bin\0"				\
	"load=tftp 8A100000 $(u-boot)\0"				\
	"u_b=protect off 1:0-1;era 1:0-1;"				\
		"cp.b 8A100000 BC400000 $(filesize)\0"			\
	"loadfs=tftp 8A100000 root.cramfs\0"				\
	"u_fs=era bc540000 bc83ffff;"				\
		"cp.b 8A100000 BC540000 $(filesize)\0"			\
	"test_tftp=tftp 8A100000 root.cramfs;run test_tftp\0"				\
	""
#else
#define	CONFIG_EXTRA_ENV_SETTINGS					\
	"update_bootloader=protect off $(bootstart) $(bootend);erase $(bootstart) $(bootend);cp.b $(loadstart) $(bootstart) $(bootsize)\0" \
	"update_runtime=protect off $(runtimestart) $(runtimeend);erase $(runtimestart) $(runtimeend);cp.b $(loadstart) $(runtimestart) $(runtimesize)\0" \
	"clean_env=protect off $(envstart) $(envend); erase $(envstart) $(envend);protect on $(envstart) $(envend)\0" \
	"runtime=bootm $(runtimestart) $(runtimeloadstart)\0" \
	""
#define CONFIG_BOOTCOMMAND	"run runtime" //"run flash_self"
#endif
#if defined(CFG_RUN_CODE_IN_RAM)
#define CONFIG_COMMANDS		(\
				(CONFIG_CMD_DFL |\
				 CFG_CMD_ASKENV	|\
				 CFG_CMD_DHCP	|\
				 CFG_CMD_ELF	|\
				 CFG_CMD_SPI	|\
				 CFG_CMD_I2C	|\
				 CFG_CMD_PING	))
#else
#define CONFIG_COMMANDS		(\
				(CONFIG_CMD_DFL & ~(CFG_CMD_LOADS|CFG_CMD_ITEST|CFG_CMD_AUTOSCRIPT|\
				 CFG_CMD_IMLS|CFG_CMD_FPGA|CFG_CMD_NFS) | CFG_CMD_NET \
				))
#endif


#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define	CFG_LONGHELP				/* undef to save memory      */

#define	CFG_PROMPT		"RT2880 # "	/* Monitor Command Prompt    */
#define	CFG_CBSIZE      256		/* Console I/O Buffer Size   */
#define	CFG_PBSIZE      (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define	CFG_MAXARGS		16		/* max number of command args*/

#define CFG_MALLOC_LEN		128*1024

#define CFG_BOOTPARAMS_LEN	128*1024



#define CFG_HZ			SYSTEM_CLOCK_RATE
#define CFG_SDRAM_BASE		0x8A000000


/*
 * for TEST
 */
#define CFG_CONSOLE_INFO_QUIET

#define	CFG_LOAD_ADDR		0x8A100000	/* default load address	*/
/* added by Leo, 2007/07/31 14:47:00 */
#define CFG_BOOTLOADER_LOAD_ADDR 0x8A200000
/* ********************************* */

#define CFG_MEMTEST_START	0x8A100000
#define CFG_MEMTEST_END		0x8A400000


#define CFG_EMBEDED_SRAM_START 0xA0800000
#define CFG_EMBEDED_SRAM_FOR_RXRING0_DESC 0xA0800000
#define CFG_EMBEDED_SRAM_FOR_TXRING0_DESC 0xA0800100
#define CFG_EMBEDED_SRAM_FOR_TXRING1_DESC 0xA0800200
#define CFG_EMBEDED_SRAM_BUF_START 0xA0800300
#define CFG_EMBEDED_SRAM_SDP0_BUF_START 0xA0804000
#define CFG_EMBEDED_SRAM_END   0xA0807FFF

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(128)	/* max number of sectors on one chip */

#define PHYS_FLASH_1		0xBC400000 /* Flash Bank #1 */

/* The following #defines are needed to get flash environment right */
#define	CFG_MONITOR_BASE	TEXT_BASE

#define	CFG_MONITOR_LEN		(192 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#define CFG_FLASH_BASE		PHYS_FLASH_1

/* added by Leo, 2007/07/30 17:58:20 */
#define CFG_FLASH_SIZE	            (3*1024*1024)	/* Flash size (bytes) */
#define CFG_BOOTLOADER_START_ADDR   0xBC400000 //CFG_FLASH_BASE
#define CFG_BOOTLOADER_SIZE         0x30000    // 192K
#define CFG_BOOTLOADER_END_ADDR     0xBC42FFFF //(CFG_FLASH_BASE + CFG_BOOTLOADER_SIZE - 1)
#define CFG_RUNTIME_START_ADDR      0xBC440000
#define CFG_RUNTIME_SIZE            0x3B0000
#define CFG_RUNTIME_END_ADDR        0xBC7EFFFF
#define CFG_RUNTIME_LOAD_ADDR       0x8A000000
#define CFG_ENV_START_ADDR          0xBC430000 //0xBC7F0000
#define CFG_ENV_END_ADDR            0xBC43FFFF //0xBC7FFFFF
/* ********************************* */

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(15 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(5 * CFG_HZ) /* Timeout for Flash Write */
#define CFG_ETH_AN_TOUT	(5 * CFG_HZ) /* Timeout for Flash Write */
#define CFG_ETH_LINK_UP_TOUT	(5 * CFG_HZ) /* Timeout for Flash Write */
#define CFG_FLASH_STATE_DISPLAY_TOUT  (2 * CFG_HZ) /* Timeout for Flash Write */


#define	CFG_ENV_IS_IN_FLASH		1
//#define CFG_ENV_IS_NOWHERE		1

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_SIZE		(64*1024)
#define CFG_ENV_ADDR		(CFG_FLASH_BASE + CFG_BOOTLOADER_SIZE)//(CFG_FLASH_BASE + CFG_FLASH_SIZE - CFG_ENV_SIZE)

#define CONFIG_FLASH_16BIT

#define CONFIG_NR_DRAM_BANKS	1

#define CONFIG_NET_MULTI
#define CFG_RX_ETH_BUFFER		60

//#define CFG_JFFS2_FIRST_BANK	1
//#define CFG_JFFS2_NUM_BANKS		1

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE		(16*1024)
#define CFG_ICACHE_SIZE		(16*1024)
#define CFG_CACHELINE_SIZE	16


#define CONFIG_LZMA		1


#define RT2880_REGS_BASE			0xA0000000


/*
 * System Controller	(0x00300000)
 *   Offset
 *   0x10  -- SYSCFG		System Configuration Register
 *   0x34  -- RSTCTRL		Reset Control Register
 *   0x38  -- RSTSTAT		Reset Status Register
 *   0x60  -- GPIOMODE		GPIO Mode Control Register
 */
#define RT2880_SYS_CNTL_BASE		(RT2880_REGS_BASE+0x00300000)
#define RT2880_SYSCFG_REG			(RT2880_SYS_CNTL_BASE+0x10)
#define RT2880_RSTCTRL_REG			(RT2880_SYS_CNTL_BASE+0x34)
#define RT2880_RSTSTAT_REG			(RT2880_SYS_CNTL_BASE+0x38)
#define RT2880_GPIOMODE_REG			(RT2880_SYS_CNTL_BASE+0x60)

#define RT2880_PIO_BASE				(RT2880_SYS_CNTL_BASE+0x600)
#define RT2880_PIODATA_REG			(RT2880_PIO_BASE+0x20)
#define RT2880_PIODIR_REG			(RT2880_PIO_BASE+0x24)

#define RT2880GPIO_DATA_LEN			24


#define RT2882_REG(x)		(*((volatile u32 *)(x)))



//#define CONFIG_UPDATE_FAIL 0
#define CONFIG_BACKUP_CODE


#endif	/* __CONFIG_H */
